         ; ZUP-F16 g{[h SAMPLE PROGRAM
         ; ASSEMBLED by F4.BAT
         $MAXIMUM
MAIN     SECTION CODE ABS=0H ALIGN=2,1
         ;
VECT_TOP EQU   0FFFF00H         ;F_ROM=256K byte
ROM_TOP  EQU   0FD0000H         ;F_ROM PROGURAM TOP ADDRESS
RAM_TOP  EQU    001000H         ;RAM TOP ADDRESS
RAM_PRO  EQU    004000H         ;RAM PROGRAM TOP ADDRESS
STACK    EQU    005000H         ;BUILT IN RAM END
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; I/O EQU TABLE
P0       EQU    00H             ;Port0
P1       EQU    01H             ;Port1
P2       EQU    06H             ;Port2
P3       EQU    07H             ;Port3
P4       EQU    0CH             ;Port4
P5       EQU    0DH             ;Port5
P6       EQU    12H             ;Port6
P7       EQU    13H             ;Port7
P8       EQU    18H             ;Port8
P9       EQU    19H             ;Port9
PA       EQU    1EH             ;PortA
P0CR     EQU    02H             ;Port0 Control
P1CR     EQU    04H             ;Port1 Control
P1FC     EQU    05H             ;Port1 Function
P2CR     EQU    08H             ;Port2 Control
P2FC     EQU    09H             ;Port2 Function
P3CR     EQU    0AH             ;Port3 Control
P3FC     EQU    0BH             ;Port3 Function
P4CR     EQU    0EH             ;Port4 Control
P4FC     EQU    0FH             ;Port4 Function
P6CR     EQU    14H             ;Port6 Control
P6FC     EQU    15H             ;Port6 Function
P7CR     EQU    16H             ;Port7 Control
P7FC     EQU    17H             ;Port7 Function
P8CR     EQU    1AH             ;Port8 Control
P8FC     EQU    1BH             ;Port8 Function
P9CR     EQU    1CH             ;Port9 Control
P9FC     EQU    1DH             ;Port9 Function
PACR     EQU    20H             ;PortA Control
PAFC     EQU    21H             ;PortA Function
ODE      EQU    2FH             ;Serial Open Drain Enable
INTE0AD  EQU    90H             ;Interrupt Enable 0&AD
INTE12   EQU    91H             ;Interrupt Enable 2/1
INTE34   EQU    92H             ;Interrupt Enable 4/3
INTE56   EQU    93H             ;Interrupt Enable 6/5
INTE78   EQU    94H             ;Interrupt Enable 8/7
INTETA01 EQU    95H             ;Interrupt Enable Timer A 1/0
INTETA23 EQU    96H             ;Interrupt Enable Timer A 3/2
INTETA45 EQU    97H             ;Interrupt Enable Timer A 5/4
INTETA67 EQU    98H             ;Interrupt Enable Timer A 7/6
INTETB0  EQU    99H             ;Interrupt Enable TMRB0
INTETB1  EQU    9AH             ;Interrupt Enable TMRB1
INTETB01V EQU    9BH            ;Interrupt Enable TMRB0/1
INTES0   EQU    9CH             ;Interrupt Enable Serial 0
INTES1   EQU    9DH             ;Interrupt Enable Serial 1
INTES2RTC EQU    9EH            ;Interrupt Enable Serial 2/RTC
INTETC01 EQU    0A0H            ;Interrupt Enable TC0/1
INTETC23 EQU    0A1H            ;Interrupt Enable TC2/3
DMA0V    EQU    80H             ;DMA 0 Request Vector
DMA1V    EQU    81H             ;DMA 1 Request Vector
DMA2V    EQU    82H             ;DMA 2 Request Vector
DMA3V    EQU    83H             ;DMA 3 Request Vector
INTCLR   EQU    88H             ;Interrupt Clear Control
DMAR     EQU    89H             ;DMA Software Request Register
DMAB     EQU    8AH             ;DMA Burst Request Register
IIMC     EQU    8CH             ;Interrupt Input Mode Control
B0CS     EQU    0C0H            ;Block 0 CS/WAITcontrol Register
B1CS     EQU    0C1H            ;Block 1 CS/WAITcontrol Register
B2CS     EQU    0C2H            ;Block 2 CS/WAITcontrol Register
B3CS     EQU    0C3H            ;Block 3 CS/WAITcontrol Register
BEXCS    EQU    0C7H            ;External CS/WAITcontrol Register
MSAR0    EQU    0C8H            ;Memory Start Address Reg0
MAMR0    EQU    0C9H            ;Memory Address Mask Reg0
MSAR1    EQU    0CAH            ;Memory Start Address Reg1
MAMR1    EQU    0CBH            ;Memory Address Mask Reg1
MSAR2    EQU    0CCH            ;Memory Start Address Reg2
MAMR2    EQU    0CDH            ;Memory Address Mask Reg2
MSAR3    EQU    0CEH            ;Memory Start Address Reg3
MAMR3    EQU    0CFH            ;Memory Address Mask Reg3
SYSCR0   EQU    0E0H            ;System Clock Control Register 0
SYSCR1   EQU    0E1H            ;System Clock Control Register 1
SYSCR2   EQU    0E2H            ;System Clock Control Register 2
EMCCR0   EQU    0E3H            ;EMC Control Register 0
DFMCR0   EQU    0E8H            ;DFM Control Register 0
DFMCR1   EQU    0E9H            ;DFM Control Register 1
TA01RUN  EQU    100H            ;Timer RUN
TA0REG   EQU    102H            ;8 bit Timer Register 0
TA1REG   EQU    103H            ;8 bit Timer Register 1
TA01MOD  EQU    104H            ;8 bit Timer Source CLK&MODE
TA1FFCR  EQU    105H            ;8 bit Timer Flip-Flop Control
TA23RUN  EQU    108H            ;Timer RUN
TA2REG   EQU    10AH            ;8 bit Timer Register 0
TA3REG   EQU    10BH            ;8 bit Timer Register 1
TA23MOD  EQU    10CH            ;8 bit Timer Source CLK&MODE
TA3FFCR  EQU    10DH            ;8 bit Timer Flip-Flop Control
TA45RUN  EQU    110H            ;Timer RUN
TA4REG   EQU    112H            ;8 bit Timer Register 0
TA5REG   EQU    113H            ;8 bit Timer Register 1
TA45MOD  EQU    114H            ;8 bit Timer Source CLK&MODE
TA5FFCR  EQU    115H            ;8 bit Timer Flip-Flop Control
TA67RUN  EQU    118H            ;Timer RUN
TA6REG   EQU    11AH            ;8 bit Timer Register 0
TA7REG   EQU    11BH            ;8 bit Timer Register 1
TA67MOD  EQU    11CH            ;8 bit Timer Source CLK&MODE
TA7FFCR  EQU    11DH            ;8 bit Timer Flip-Flop Control
TB0RUN   EQU    180H            ;Timer Control
TB0MOD   EQU    182H            ;16bit Timer Source CLK&MODE
TB0FFCR  EQU    183H            ;16 bit Timer Flip-Flop Control
TB0RG0   EQU    188H            ;16 bit Timer Register 0
TB0RG0L  EQU    188H            ;16 bit Timer Register 0L
TB0RG0H  EQU    189H            ;16 bit Timer Register 0H
TB0RG1   EQU    18AH            ;16 bit Timer Register 1
TB0RG1L  EQU    18AH            ;16 bit Timer Register 1L
TB0RG1H  EQU    18BH            ;16 bit Timer Register 1H
TB0CP0   EQU    18CH            ;Capture Register 0
TB0CP0L  EQU    18CH            ;Capture Register 0L
TB0CP0H  EQU    18DH            ;Capture Register 0H
TB0CP1   EQU    18EH            ;Capture Register 1
TB0CP1L  EQU    18EH            ;Capture Register 1L
TB0CP1H  EQU    18FH            ;Capture Register 1H
TB1RUN   EQU    190H            ;Timer Control
TB1MOD   EQU    192H            ;16bit Timer Source CLK&MODE
TB1FFCR  EQU    193H            ;16 bit Timer Flip-Flop Control
TB1RG0   EQU    198H            ;16 bit Timer Register 0
TB1RG0L  EQU    198H            ;16 bit Timer Register 0L
TB1RG0H  EQU    199H            ;16 bit Timer Register 0H
TB1RG1   EQU    19AH            ;16 bit Timer Register 1
TB1RG1L  EQU    19AH            ;16 bit Timer Register 1L
TB1RG1H  EQU    19BH            ;16 bit Timer Register 1H
TB1CP0   EQU    19CH            ;Capture Register 0
TB1CP0L  EQU    19CH            ;Capture Register 0L
TB1CP0H  EQU    19DH            ;Capture Register 0H
TB1CP1   EQU    19EH            ;Capture Register 1
TB1CP1L  EQU    19EH            ;Capture Register 1L
TB1CP1H  EQU    19FH            ;Capture Register 1H
SC0BUF   EQU    200H            ;Serial Channel 0 Buffer
SC0CR    EQU    201H            ;Serial Channel 0 Control
SC0MOD0  EQU    202H            ;Serial Channel 0 Mode0
BR0CR    EQU    203H            ;Baud Rate Control
BR0ADD   EQU    204H            ;Serial Channel 0 K ݒ Reg
SC0MOD1  EQU    205H            ;Serial Channel 0 Mode1
SIRCR    EQU    207H            ;IrDA Control Register
SC1BUF   EQU    208H            ;Serial Channel 1 Buffer
SC1CR    EQU    209H            ;Serial Channel 1 Control
SC1MOD0  EQU    20AH            ;Serial Channel 1 Mode0
BR1CR    EQU    20BH            ;Baud Rate Control
BR1ADD   EQU    20CH            ;Serial Channel 1 K ݒ Reg
SC1MOD1  EQU    20DH            ;Serial Channel 1 Mode1
SBI0CR1  EQU    240H            ;Serial Bus Interface Control Register 1
SBI0DBR  EQU    241H            ;SBI Buffer Register
I2C0AR   EQU    242H            ;I2CBUS Address Register
SBI0CR2  EQU    243H            ;Serial Bus Interface Control Register 2 Write
SBI0SR   EQU    243H            ;Serial Bus Interface Control Register 2 Read
SBI0BR0  EQU    244H            ;Serial Bus Interface Baud Rate Register 0
SBI0BR1  EQU    245H            ;Serial Bus Interface Baud Rate Register 1
ADMOD0   EQU    2B0H            ;AD MODE Reg0
ADMOD1   EQU    2B1H            ;AD MODE Reg1
ADREG04L EQU    2A0H            ;AD Result Reg 0/4 low
ADREG04H EQU    2A1H            ;AD Result Reg 0/4 high
ADREG15L EQU    2A2H            ;AD Result Reg 1/5 low
ADREG15H EQU    2A3H            ;AD Result Reg 1/5 high
ADREG26L EQU    2A4H            ;AD Result Reg 2/6 low
ADREG26H EQU    2A5H            ;AD Result Reg 2/6 high
ADREG37L EQU    2A6H            ;AD Result Reg 3/7 low
ADREG37H EQU    2A7H            ;AD Result Reg 3/7 high
WDMOD    EQU    300H            ;Watch Dog Timer Mode
WDCR     EQU    301H            ;Watch Dog Timer Control Register
RTCCR    EQU    310H            ;vp^C} Control Reg
         ;
         ; USER EQU TABLE
F_FROM   EQU    1024H           ;FROM ADDRESS
F_TO     EQU    1028H           ;TO ADDRESS
F_CT     EQU    102CH           ;byte CT
M_ADRS   EQU    108CH           ;F_ROM   
TEMP     EQU    1A00H           ;TEMP BUFF=1A00H -> 1BFFH  512byte
CB0      EQU    1C00H           ;ֳ TEMP BFF
CB2      EQU    CB0+2
CB4      EQU    CB0+4
CB6      EQU    CB0+6
TP0      EQU    CB0+8
TP2      EQU    CB0+10
TP4      EQU    CB0+12
TP6      EQU    CB0+14
P1FIX    EQU    1C10H           ;ƭخ SCAN ò -
P4FIX    EQU    P1FIX+1
P5FIX    EQU    P1FIX+2
P7FIX    EQU    P1FIX+3
P8FIX    EQU    P1FIX+4
PAFIX    EQU    P1FIX+5
P1M      EQU    P1FIX+8
P4M      EQU    P1FIX+9
P5M      EQU    P1FIX+10
P7M      EQU    P1FIX+11
P8M      EQU    P1FIX+12
PAM      EQU    P1FIX+13
M_POINT  EQU    1D00H           ;DUMP ˮ į ڽ
RXBP1    EQU    1044H           ;RX1 ޭް߲
SEG1     EQU    1010H           ;7 LED DATA BFF
SEG2     EQU    1011H
SEG3     EQU    1012H
SEG4     EQU    1013H
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; RAM ݶ  ۸
         ORG    RAM_PRO         ;004000H = RAM PROGRAM TOP
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; F_ROM ORDER (1020H) SET CALL
         ; ORSER 10H -> 16H=ۯ-  1FH=߲-  30H=
         ;  ٰݶ ޳ F_ROMŲ ۸Ѧ ̪ ޷Ų
F_ROM:   DI

F_LOOP:  LD     (WDCR),4EH      ;WD TIMER CT CLR
         ;
         CAL    NZ,ERSCHK       ;ERASE STATUS CHK
         CAL    F_ROM1          ;F_ROM ODR CHK & MONITOR
         ;
         CP     (1020H),00H     ;F_ROM ODR CHK
         J      NZ,F_LOOP       ;F_ROM ODR CHK & MONITOR
         EI
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; F_ROM ODR CHK
F_ROM1:  LD     A,(1020H)       ;MODE No CHK
         CP     A,30H           ; -
         J      Z,M30_WR
         CP     A,31H           ; - 
         J      Z,M31_WR
         ;
         CP     A,10H           ;-=0 ?
         J      Z,PM_0
         CP     A,11H           ;-=1 ?
         J      Z,PM_1
         CP     A,12H           ;-=2 ?
         J      Z,PM_2
         CP     A,13H           ;-=3 ?
         J      Z,PM_3
         CP     A,14H           ;-=4 ?
         J      Z,PM_4
         CP     A,15H           ;-=5 ?
         J      Z,PM_5
         CP     A,16H           ;-=6 ?
         J      Z,PM_6
         CP     A,1FH           ;-=F ?
         J      Z,C_ERAS        ;-: F=߲-
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; F_FORM, F_TO, F_CT - - No 30Ľ
         ; F_CT= ܰ 
         ; FROM POINTER  TO POINTER 
         ; ߲ INC &  DEC
M30_WR:  LD     XHL,(F_FROM)    ;FROM POINTER (RAM)
         LD     XDE,(F_TO)      ;TO POINTER   (F_ROM)
         LD     WA,(XHL)        ;LOAD WR DATA
         INC    2,XHL           ;FROM POINTER INC & SAVE
         LD     (F_FROM),XHL
         LD     (1020H),31H     ;NEXT MODE No
         ;
         ; F_ROM -۸ ò
F_WR:    LD     (0FCAAAAH),0AAH  ;1st bus WR CYCLE
         LD     (0FC5554H),55H   ;2nd bus WR CYCLE
         LD     (0FCAAAAH),0A0H  ;3rd bus WR CYCLE
         LD     (XDE),WA        ;4th bus WR CYCLE WRITE DATA
         LD     (1034H),XDE     ;  
         INC    2,XDE           ;INC F_ROM POINTER & SAVE
         LD     (F_TO),XDE
         LD     (1032H),WA      ; - 
         AND    (1031H),0F0H    ;F_ROM -۸  FLG CLR
         LDW    (1038H),0FFFFH  ;ݼ  
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; F_ROM  ޮ CHK
M31_WR:  DECW   1,(1038H)
         CPW    (1038H),0       ; CHK
         JP     Z,R_RESET
         CAL    F_STAT          ;ׯ ROM - CHK ()
         LD     A,07H
         AND    A,(1031H)       ;F_ROM -۸  FLG CHK
         RET    Z               ;F_ROM -۸ ޯ
         BIT    2,(1031H)        ;TIME OVER FLG CHK
         J      Z,NXT_WR        ;ޮ خ
         J      R_RESET         ;TIME OVER
         RET
         ;
NXT_WR:  LD     XBC,(F_CT)      ;word  
         SUB    XBC,1
         LD     (F_CT),XBC
         J      NZ,M30_WR       ;· 
         LD     (1020H),0       ;MODE No -> "0"
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; - - CHK
PM_0:    LD     XHL,0FC0000H    ;ۯ= FC0000H -> FCFFFFH
         J      B_ERAS
PM_1:    LD     XHL,0FD0000H    ;ۯ= FD0000H -> FDFFFFH
         J      B_ERAS
PM_2:    LD     XHL,0FE0000H    ;ۯ= FE0000H -> FEFFFFH
         J      B_ERAS
PM_3:    LD     XHL,0FF0000H    ;ۯ= FF0000H -> FF7FFFH
         J      B_ERAS
PM_4:    LD     XHL,0FF8000H    ;ۯ= FF8000H -> FF9FFFH
         J      B_ERAS
PM_5:    LD     XHL,0FFA000H    ;ۯ= FFA000H -> FFBFFFH
         J      B_ERAS
PM_6:    LD     XHL,0FFC000H    ;ۯ= FFC000H -> FFFFFFH
         J      B_ERAS
         ;
         ; ߲-  ʯ
C_ERAS:  LD     (0FCAAAAH),0AAH  ;1st bus WR CYCLE
         LD     (0FC5554H),55H   ;2nd bus WR CYCLE
         LD     (0FCAAAAH),80H   ;3rd bus WR CYCLE
         LD     (0FCAAAAH),0AAH  ;4th bus WR CYCLE
         LD     (0FC5554H),55H   ;5th bus WR CYCLE
         LD     (0FC0AAAH),10H   ;6th bus WR CYCLE - 
         LD     XHL,0FC0000H     ;   
         LD     (1034H),XHL
         LDW    (1032H),0FFFFH   ;  - 
M20SET1: LD     XHL,64FFFFH     ;ݼ  ABOUT 30sec
         LD     (1038H),XHL
         LD     (1020H),20H      ;MODE=20H TIMCHK-  - ݼ
         AND    (1031H),0F0H     ;F_ROM -۸  FLG CLR
         RET
         ;
         ; ۯ -  ʯ
B_ERAS:  LD     (0FCAAAAH),0AAH  ;1st bus WR CYCLE
         LD     (0FC5554H),55H   ;2nd bus WR CYCLE
         LD     (0FCAAAAH),80H   ;3rd bus WR CYCLE
         LD     (0FCAAAAH),0AAH  ;4th bus WR CYCLE
         LD     (0FC5554H),55H   ;5th bus WR CYCLE
         LD     (XHL),30H       ;6th bus WR CYCLE - 
         OR     XHL,00000FFEH   ;   
         LD     (1034H),XHL
         LDW    (1032H),0FFFFH   ;  - 
         LD     XHL,64FFFFH     ;ݼ  ABOUT 30sec
         LD     (1038H),XHL
         LD     (1020H),20H      ;MODE=20H TIMCHK-  - ݼ
         AND    (1031H),0F0H     ;F_ROM -۸  FLG CLR
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; ׯ ROM - CHK
F_STAT:  LD     XHL,(1034H)     ;ׯ ROM  ڽ
         LD     A,(XHL)         ;ĸ ޯ CHK
         LD     (1030H),A       ;- 
         LD     W,A
         LD     C,(1032H)       ;-ݸ ޯ 
         CPL    C
         AND    C,80H
         AND    A,80H
         CP     A,C
         JP     Z,ON_BUSY       ;̲
         LD     WA,(XHL)        ; - CHK
         CP     WA,(1032H)
         J      NZ,D_DEF        ; - ̲
         SET    0,(1031H)       ;ޮ خ FLG ON
         RET
D_DEF:   SET    1,(1031H)       ;- ̲ FLG ON
         RET
ON_BUSY: BIT    5,W             ;TIME OVER CHK
         RET    Z
         SET    2,(1031H)       ;TIME OVER FLG ON
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ;
ERSCHK:  CP     (1020H),20H     ;ڰ Ӱ
         RET    NZ
         LD     XHL,(1038H)
         SUB    XHL,1           ;ݼ  ABOUT 30sec
         LD     (1038H),XHL
         JP     Z,R_RESET
         CAL    F_STAT          ;ׯ ROM - CHK (-)
         LD     A,07H
         AND    A,(1031H)       ;F_ROM -۸  FLG CHK
         RET    Z               ;F_ROM -۸ ޯ
         BIT    2,(1031H)       ;TIME OVER FLG CHK
         J      Z,ERSEND        ;ޮ خ
         J      R_RESET         ;TIME OVER
         RET
ERSEND:  LD     (1020H),0       ;MODE No -> "0"
         RET
         ;
         ; F_ROM ѱ ׸ ر
R_RESET: LD     (1020H),0       ;MODE No -> "0"
         SET    0,(103FH)       ;F_ROM ޮ bit ON
       ;  RET
         ; F_ROM ذ޻  ޽
         LD     (0FCAAAAH),0AAH  ;1st bus WR CYCLE
         LD     (0FC5554H),55H   ;2nd bus WR CYCLE
         LD     (0FCAAAAH),0F0H  ;3rd bus WR CYCLE
         RET
         NOP
RAM_END: NOP                    ;RAM ݶ  ۸ END
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;       INITIAL ROUTINE               ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ORG    ROM_TOP
START:   LD     (WDCR),4EH      ;WD TIMER CT CLR
         LD     (WDMOD),0E2H    ;WDT ON, 213msec CLR,RESET MODE
         ;
         LD     (DFMCR1),0BH    ;DFM ۸ SET
         LD     (DFMCR0),40H    ;DFM,LUP=RUN LUP2^12
LP_LUP:  BIT    5,(DFMCR0)      ;LUP TIME UP CHK
         J      NZ,LP_LUP       ;WAIT LOOP
         LD     (DFMCR0),80H    ;fc=fdfm OUT 6.144MHz * 4
         LD     (SYSCR1),00H    ;CLK=high speed  24.576MHz
         LD     (1000H),00H     ;DMY
         LD     XSP,STACK       ;5000H
         LD     (EMCCR0),2AH    ;ALE = ON
         ;
         LD     (P1CR),00H      ;P1CR=0 & P1FC=1
         LD     (P1FC),0FFH     ;P1=A/D Bus
         LD     (P2CR),0FFH     ;P2CR=1=OUT
         LD     (P2FC),0FH      ;P2=PPPPAAAA
         LD     (P2),0FFH       ;
         LD     (P3),78H        ;P3=-1111000
         LD     (P3CR),7FH      ;P3=-ooooooo
         LD     (P3FC),07H      ;P3=-PPPPccc
         LD     (P4FC),02H      ;P4=----PPcP
         LD     (P4CR),0EH      ;P4=----oooi
         ;
         LD     (P6),54H        ;P6=-101-1--
         LD     (P6FC),08H      ;P6=-PPPIPPP
         LD     (P6CR),77H      ;P6=-oooiooo
         LD     (P7FC),20H      ;P7=--TPPPPP
         LD     (P7CR),2FH      ;P7=--oioooo
         LD     (P8FC),00H      ;P8=PPPPPPPP
         LD     (P8CR),0FFH     ;P8=oooooooo
         LD     (P9FC),08H      ;P9=PPPSSPPP
         LD     (P9CR),0EFH     ;P9=oooioooo
    ;     LD     (P9FC),08H      ;P9=PPPSSPPP
    ;     LD     (P9CR),0EAH     ;P9=oooioioi
         LD     (PAFC),00H      ;PA=PPPPPPPP
         LD     (PACR),0FFH     ;PA=oooooooo
         ;
         LD     (MSAR1),10H     ;CS_1: 1Mbyte SRAM
         LD     (MAMR1),3FH     ;100000H -> 1FFFFFH
         LD     (B1CS),83H      ;16bit bus 0wait
         ;
         ;      RAM CLEAR
         LD     WA,0            ;CLEAR DATA
         LD     XHL,1000H       ;RAM TOP
         LD     BC,(1800H-1000H)/2   ;LENGTH
         LD     (XHL),WA
         LD     XDE,1002H       ;to ADDRESS
         LDIRW
         LD     (WDCR),4EH      ;WD TIMER CT CLR
         ;
         ;   RAM ۸ ݿ
         LD     XHL,0FC0000H
         LD     XDE,4000H
         LD     BC,(RAM_END-RAM_PRO)/2
         LDIRW
         LD     (WDCR),4EH      ;WD TIMER CT CLR
         ;
         ;    < TIMER 0,1  >
         LD     (TA01RUN),00H   ;TA01 STOP & CLR
         LD     (TA01MOD),09H   ;8bit TIM,TIM1=xT16,TIM0= xT1
         LD     (TA1FFCR),00H   ;OUT F/F OFF
     ;    LD     (TA0REG),153    ;0.3255sec * 153=50sec  @24.576MHz
         LD     (TA1REG),240    ;5.2sec * 240=1.25msec  @24.576MHz
         LD     (INTETA01),50H  ;TA1=INT ENABLE, LEVEL5
         LD     (TA01RUN),06H   ;PRESCALER, TA 1 RUN
         ;
         ;    <  رI/O (0)  >
         LD     (BR0CR),1AH     ;9600bps  @24.576MHz
         LD     (SC0MOD0),09H   ;RX=DISABLE, 8bit, B/G USE
         LD     (SC0CR),00H     ;NOON PARI
         ;
         ;    <  رI/O (1)  >
         LD     (BR1CR),1AH     ;9600bps  @24.576MHz
     ;    LD     (BR1CR),15H     ;19200bps  @24.576MHz
     ;    LD     (BR1CR),0AH     ;38400bps  @24.576MHz
         LD     (SC1MOD0),29H   ;RX=ENABLE, 8bit, B/G USE
     ;    LD     (SC1MOD0),09H   ;RX=DISABLE, 8bit, B/G USE
         LD     (SC1CR),00H     ;NOON PARI
         LD     (INTES1),04H    ;TX INT=OFF RX INT=LV4
     ;    LD     (INTES1),00H    ;TX INT=OFF RX INT=OFF
         ;
         ;    <  A/D ް  >
         LD     (ADMOD1),81H    ;Vref -> ON, ch=0->1 
         LD     (ADMOD0),02H    ;ݸӰ ٽӰ
         LD     (INTCLR),27H    ;A/D INT FLG CLR
    ;     LD     (INTE0AD),40H   ;A/D ݶ خ غ ENABLE
         LD     (104EH),64      ;AD  Ƽ
         ;
         ;    < INT 0 غ  >
         LD     (IIMC),04H      ;INT0_Z= غ
         LD     (INTCLR),0AH    ;INT0_Z FLG CLR
         LD     (INTE0AD),45H   ;INT0_Z & A/D ݶ خ غ ENABLE

         ;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;
         LD     (WDCR),4EH      ;WD TIMER CT CLR
         LD     (1001H),01H     ;INTTA1غ  SIFT UP bit
         LD     (1003H),80      ;                 1.25ms*n CT INITIAL
         LD     (1005H),10      ;                 100ms*n CT INITIAL
         ;
         CAL    LCD_INI         ;LCD INITIAL
         CAL    D_CLR           ;ˮ CLR
         CAL    MD_C10          ;ADC خ ˮ Ӱ
         CAL    Srch_F          ;F_ROM SAVEڽ ޽
         ;
         ; 7 LED "1234" ˮ
         LD     (SEG1),01H      ;SEGMENT DATA "1"
         LD     (SEG2),01H      ;             "2"
         LD     (SEG3),03H      ;             "3"
         LD     (SEG4),05H      ;             "4"
         LD     (P7),(SEG1)     ;SEG DATA
         RES    6,(P3)          ;LATCH -> low
         SET    6,(P3)          ;LATCH -> high
         LD     (P7),(SEG2)     ;SEG DATA
         RES    5,(P3)          ;LATCH -> low
         SET    5,(P3)          ;LATCH -> high
         LD     (P7),(SEG3)     ;SEG DATA
         RES    4,(P3)          ;LATCH -> low
         SET    4,(P3)          ;LATCH -> high
         LD     (P7),(SEG4)     ;SEG DATA
         RES    3,(P3)          ;LATCH -> low
         SET    3,(P3)          ;LATCH -> high
         ;
         LD     XHL,1000H       ;DUMP Ƽ ߲
         LD     (M_POINT),XHL
         ;
         EI                     ;غ ɳ
         J      BEGIN           ;JP MAIN ROUTINE
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;    INITIAL SUB ROUTINE         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; LCD INITIAL ROUTINE
LCD_INI: LD     A,5FH           ;P/S ۰: HPM=1, VC=1, VF=1, P=1
         CAL    C_OUT           ; خ
         LD     A,42H           ;PW ۰: OSC=1, PW=0
         CAL    C_OUT           ; خ
         LD     A,39H           ;DISP ۰: C=1, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         ;
         LD     A,60H           ;CS=0
         CAL    C_OUT           ; خ
         LD     A,3BH           ;DISP ۰: C=1, B=0, RE=1, D=1
         CAL    C_OUT           ; خ
         LD     A,60H           ;SS=0
         CAL    C_OUT           ; خ
         LD     A,39H           ;DISP ۰: C=1, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; F_ROMŲ  SAVE SETMEMޮγ į߱ڽ ޽
Srch_F:  LD     XHL,0FFBFF8H    ;FFBFF8H  8  
LP_HED1: BIT    7,(XHL)         ;  bit7 0
         J      Z,FINDS
         SUB    XHL,8           ;16byte  CHK
         CP     XHL,0FFA008H    ;LOW LIMIT ?
         J      NC,LP_HED1
         LD     XHL,0FFA000H    ;̫ ߲
         LD     (M_ADRS),XHL    ;F_ROM   
         RET
FINDS:   LD     (M_ADRS),XHL    ;F_ROM   
         RET
         ;
PUT120:  LDW    (1082H),120
         RET
PUT70:   LDW    (1086H),70
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;          DATA TABLE                 ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;
         ;        0123456789ABCDEF        ;ADC خ bit ˮ
TB_ADC   DB      "ch0 ADC     bit "
         DB      "ch1 ADC     bit "
         DB      00H
         ;
         ;        0123456789ABCDEF        ;F_ROM  EDIT ˮ
TB_FRM   DB      "OLD DATA        "
         DB      "NEW DATA        "
         DB      00H
         ;
         ;        0123456789ABCDEF        ;F_ROM   ˮ
TB_FRM1  DB      "F_ROMЦ ޯ"
         DB      00H
         ;
         ;        0123456789ABCDEF        ;F_ROM  خ ˮ
TB_FRM2  DB      "F_ROM خ"
         DB      " SET ø޻"
         DB      00H
         ;
         ;        0123456789ABCDEF        ;ި   ˮ
TB_SENTK DB      "ٶ޷  د "
         DB      "̧       "
         DB      00H
         ;
         ;        0123456789ABCDEF        ;ݹ ˮ
TB_ONGN  DB      "   ݹ Ӱ   "
         DB      00H
         ;
         ;        0123456789ABCDEF        ;BLANK DISP
TB_BLK   DB      "                "
         DB      "                "
         DB      00H
         ;
         ;        0123456789ABCDEF        ;TEST DISP
TB_TST   DB      "0123456789ABCDEF"
         DB      ""
         DB      00H
         ;
         ;      ** <--  Ŷ޻ 11=1sec, 10=750msec, 01=500msec 00=250msec
         ;        ** <--    11=    00=
         ;          **** <-- ݶ  0000=801Hz(̧), 1111=3594Hz()
TB_HARU  DB     10111000B       ;   " ٶ  "
         DB     01110110B       ;
         DB     01110111B       ;̧
         DB     10111000B       ;
         DB     10011001B       ;
         DB     10111000B       ;
         DB     01110110B       ;
         DB     01110111B       ;̧
         DB     10111000B       ;
         DB     10111011B       ;
         DB     10011001B       ;
         DB     10111000B       ;
         DB     10110110B       ;
         DB     01110100B       ;
         DB     11110101B       ;
         ;
         DB     10111000B       ;
         DB     01011001B       ;
         DB     01111000B       ;
         DB     10110110B       ;
         DB     10111000B       ;
         DB     10111011B       ;
         DB     01111100B       ;
         DB     01111011B       ;
         DB     10011001B       ;
         DB     10111011B       ;
         DB     10111000B       ;
         DB     10111101B       ;
         DB     10111100B       ;
         DB     10111000B       ;
         DB     11111011B       ;
         DB     00H             ;į 
         DB     00H
         ;
         ;      ** <--  Ŷ޻ 11=1sec, 10=750msec, 01=500msec 00=250msec
         ;        ** <--    11=    00=
         ;          **** <-- ݶ  0000=801Hz(̧), 1111=3594Hz()
TB_TULIP DB     10110100B       ;
         DB     10110101B       ;
         DB     11110110B       ;
         DB     10110100B       ;
         DB     10110101B       ;
         DB     11110110B       ;
         DB     10111000B       ;
         DB     10110110B       ;
         DB     10110101B       ;
         DB     10110100B       ;
         DB     10110101B       ;
         DB     10110110B       ;
         DB     11110101B       ;
         ;
         DB     10110100B       ;
         DB     10110101B       ;
         DB     11110110B       ;
         DB     10110100B       ;
         DB     10110101B       ;
         DB     11110110B       ;
         DB     10111000B       ;
         DB     10110110B       ;
         DB     10110101B       ;
         DB     10110100B       ;
         DB     10110101B       ;
         DB     10110110B       ;
         DB     11110100B       ;
         ;
         DB     10111000B       ;
         DB     10111000B       ;
         DB     10110110B       ;
         DB     10111000B       ;
         DB     10011001B       ;
         DB     10011001B       ;
         DB     11111000B       ;
         DB     10110110B       ;
         DB     10110110B       ;
         DB     10110101B       ;
         DB     10110101B       ;
         DB     11110100B       ; 
         DB     00H             ;į 
         DB     00H

         ;      ** <--  Ŷ޻ 11=1sec, 10=750msec, 01=500msec 00=250msec
         ;        ** <--    11=    00=
         ;          **** <-- ݶ  0000=801Hz(̧), 1111=3594Hz()
TB_BZ    DB     10111111B       ;     ̧
         DB     10111110B       ;̧
         DB     10111101B       ;
         DB     10111100B       ;

         DB     10111011B       ;
         DB     10111010B       ;
         DB     10011001B       ;
         DB     10111000B       ;
         DB     10110111B       ;̧
         DB     10110110B       ;
         DB     10110101B       ;
         DB     10110100B       ; 

         DB     10110011B       ;
         DB     10110010B       ;
         DB     10110001B       ;
         DB     10110000B       ;̧
         DB     00H             ;į 
         DB     00H
         ;
         ; f=6.144/32/160=1200Hz ޭ '' Ľ
ONKAI    DB     240             ;+0 ̧
         DB     214             ;+1 
         DB     190             ;+2 
         DB     169             ;+3 
         DB     160             ;+4  ޭ ަ 1200Hz Ľ
         DB     143             ;+5 
         DB     127             ;+6 
         DB     120             ;+7 ̧
         DB     107             ;+8 
         DB     95              ;+9 
         DB     85              ;+10 
         DB     80              ;+11 
         DB     72              ;+12 
         DB     64              ;+13 
         DB     60              ;+14 ̧
         DB     53              ;+15 
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; INTERRUPT SERVICE ROUTINE
SWI_1:   RETI                   ;SOFTWARE INT 1   VECT=04H
SWI_2:   RETI                   ;             2   VECT=08H
SWI_3:   RETI                   ;             3   VECT=0CH
SWI_4:   RETI                   ;             4   VECT=10H
SWI_5:   RETI                   ;             5   VECT=14H
SWI_6:   RETI                   ;             6   VECT=18H
SWI_7:   RETI                   ;             7   VECT=1CH
NMIINT:  RETI                   ;NOON MASK INT    VECT=20H
WDT_OVR: RETI                   ;WDT TIME OVER    VECT=24H
         ;
INT0_Z:  CAL    BEEP
         RETI                   ;INT 0 TERMINAL   VECT=28H
INT1_Z:  RETI                   ;INT 1 TERMINAL   VECT=2CH
INT2_Z:  RETI                   ;INT 2 TERMINAL   VECT=30H
INT3_Z:  RETI                   ;INT 3 TERMINAL   VECT=34H
INT4_Z:  RETI                   ;INT 4 TERMINAL   VECT=38H
         ;
INT5_Z:  RETI                   ;INT 5 TERMINAL   VECT=3CH
INT6_Z:  RETI                   ;INT 6 TERMINAL   VECT=40H
INT7_Z:  RETI                   ;INT 7 TERMINAL   VECT=44H
INT8_Z:  RETI                   ;INT 8 TERMINAL   VECT=48H
INTTA0:  RETI                   ;8bit TIM_0 INT   VECT=4CH
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; 1,25msec 莞 
         ; 1.25msec *n, 10msec, 100msec, 1sec ض׸ަ ¸
INTTA1:  LDF    1               ;8bit TIM_1 INT   VECT=50H
         CAL    AD_STAT         ;ADݶݦ  
         CP     (100AH),0       ;1.25* n AUX TIM
         J      Z,LV_TA1
         DEC    1,(100AH)       ;DEC AUX TIM
LV_TA1:  LD     XHL,1000H
         LD     (XHL),0FFH      ;1.25msec FLG ON
         INC    1,XHL           ;SIFT UP bit MEMO
         LD     A,(1002H)       ;1.25*N FLG
         OR     A,(XHL)
         LD     (1002H),A
         RLC    (XHL)           ;SIFT UPed
         ;
         DEC    1,(1003H)       ;100msec CT
         J      NZ,TR1RET
         LD     (1003H),80      ;REINITIAL
         LD     (1004H),0FFH
         DEC    1,(1005H)       ;1sec CT
         J      NZ,TR1RET
         LD     (1005H),10      ;REINITIAL
         LD     (1006H),0FFH     
TR1RET:  RETI
         ;
         ; A/D ݶ  ODR 
AD_STAT: BIT    6,(ADMOD0)      ;ADݶ BUSY FLG CHK
         RET    NZ              ;ݶ
         SET    0,(ADMOD0)      ;A/D 
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;
INTTA2:  RETI                   ;8bit TIM_2 INT   VECT=54H
INTTA3:  RETI                   ;8bit TIM_3 INT   VECT=58H
INTTA4:  RETI                   ;8bit TIM_4 INT   VECT=5CH
INTTA5:  RETI                   ;8bit TIM_5 INT   VECT=60H 
INTTA6:  RETI                   ;8bit TIM_6 INT   VECT=64H
INTTA7:  RETI                   ;8bit TIM_7 INT   VECT=68H
         ;
INTTB00: RETI                   ;16bit TIM0 TRG0  VECT=6CH
INTTB01: RETI                   ;16bit TIM0 TRG1  VECT=70H
INTTB10: RETI                   ;16bit TIM1 TRG0  VECT=74H
INTTB11: RETI                   ;16bit TIM1 TRG1  VECT=78H
INTTBOF0: RETI                  ;16bit TIM0       VECT=7CH
INTTBOF1: RETI                  ;16bit TIM1       VECT=80H
         ;
         ;
INTRX0:  RETI
         PUSH   XWA
         LD     A,(SC0CR)       ;ERR CHK
         LD     W,(SC0BUF)      ;READ RX DATA
         AND    A,1CH
         J      NZ,LABRX0       ;ERR
         LD     (1069H),W       ;DATA STORE
         SET    4,(1044H)       ;RECEIVED FLG ON
LABRX0:  POP    XWA
         RETI                   ;SIO_0 RX         VECT=84H
         ;
INTTX0:  RETI                   ;SIO_0 TX         VECT=88H
         ;
         ; νĶ ޭ غ
INTRX1:  PUSH   WA
         LD     A,(SC1CR)       ;ERR CHK
         LD     W,(SC1BUF)      ;READ RX DATA
         AND    A,1CH
         J      NZ,LABRX1       ;ERR
         LD     (1089H),W       ;DATA STORE
         SET    7,(100FH)       ;RECEIVED FLG ON
LABRX1:  POP    WA
         RETI                   ;SIO_1 RX         VECT=8CH
         ;
INTTX1:  RETI                   ;SIO_1 TX         VECT=90H
INTSBI:  RETI                   ;ر޽̪  VECT=94H
INTRTC:  RETI                   ;Ĺֳغ     VECT=98H
         ;
         ; A/D ݶ غ
INT_AD:  SET    5,(1050H)       ;A/D DATA READY FLG ON
         RETI                   ;A/D CONVERTED    VECT=9CH
         ;
INTTC0:  RETI                   ;ϲDMAخ    VECT=A0H
         ;
         ; DMAݿ خ غ
INTTC1:  LD     (INTETC01),00H
         RES    2,(100FH)       ;ر ݿ FLG OFF
         LD     (100AH),2       ;1.25 *n TIM SET
         RETI                   ;ϲDMAخ    VECT=A4H
         ;
INTTC2:  RETI                   ;ϲDMAخ    VECT=A8H
INTTC3:  RETI                   ;ϲDMAخ    VECT=ACH

         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; MAIN ROUTINE
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BEGIN:   LD     (WDCR),4EH      ;WD TIMER CT CLR
         ;
         BIT    0,(1002H)       ;1.25*8=10msec FLG
         CAL    NZ,PSCAN        ; ƭخ SCAN
         ;
         BIT    0,(1004H)       ;100msec FLG CHK
         CAL    NZ,TIM100       ;100msec ROUTINE
         ;
         BIT    2,(1002H)       ;1.25*8=10msec FLG
         CAL    NZ,TIM10        ;10msec FLG
         ;
         BIT    5,(1050H)       ;A/D DATA READY FLG CHK
         CAL    NZ,AD_AVE       ;AD ݶ Ͳ ݼ
         ;
         BIT    7,(100FH)       ;ޭ -  FLG CHK
         CAL    NZ,RX1CHK       ;$ CR,LFަ ޭݽ
         ;
         BIT    6,(100FH)       ;ޭݶخ FLG CHK
         CAL    NZ,LOP_BK       ;LOOP BACK 
         ;
         BIT    2,(1050H)       ;KEY DATA READY FLG CHK
         CAL    NZ,KEYDATA      ;- ƭخ ASCII- CHK & ܹ
         ;
         BIT    4,(1002H)       ;1.25*8=10msec FLG
         CALL   NZ,KEYSCAN      ;KEY SCAN ODR
         ;
         BIT    0,(1006H)       ;1sec FLG CHK
         CAL    NZ,TIM1S        ;1sec ROUTINE
         ;
         CP     (1021H),00H     ;Ų F_ROM ޮ ӰNo CHK
         CAL    NZ,F_CONT       ;0 ޲ F_ROM CONTROL
         ;
         CP     (1020H),00H     ;Ų F_ROM ODR CHK
         CAL    NZ,F_ROM        ;Ų F_ROM ODR CHK & MONITOR
         ;
         J      BEGIN
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;        SUB ROUTINE                ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; ޭݶخ FLG  LOOP BACK ݦ 
         ; TX BFF TOP=1200H
LOP_BK:  BIT    2,(100FH)       ;ر ݿ FLG CHK
         RET    NZ              ;ݿ
         CP     (100AH),0       ; 1byte خ 
         RET    NZ
         RES    6,(100FH)       ;ޭݶخ FLG OFF
         LD     BC,(108AH)      ;TX byte CT
         LD     XHL,1200H       ;TX BFF TOP
         CAL    TXSIO1


         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; ͯ $ CR,LFmax256byte ޭݽ
         ; RX BFF TOP=1100H  TX BFF TOP=1200H
RX1CHK:  RES    7,(100FH)       ;RX0 ޭ -  FLG OFF
         LD     A,(1088H)       ;- No CHK
         CP     A,0
         JP     Z,MDR10         ;ͯ $ 
         CP     A,1
         JP     Z,MDR11         ;CR ޭ
         CP     A,2
         JP     Z,MDR12;        ;LF ޭ
         RET
         ;
         ; ͯ $ 
MDR10:   CP     (1089H),'$'     ;ͯ $ ?
         RET    NZ
         LD     XHL,1100H       ;RX BFF ĳ ڽ
         LD     (XHL),(1089H)   ;ޭ - SAVE
         INC    1,L
         LD     (1086H),L       ;߲ LSB 
         LD     (1088H),1       ;NEXT MD No
         RET
         ;
MDR11:   LD     A,(1089H)       ;RX DATA SAVE & CHK
         LD     XHL,1100H       ;߲ ް
         LD     L,(1086H)       ;߲ LSB
         LD     (XHL),A         ;ޭ - SAVE
         INC    1,L
         J      Z,MD0SETR
         LD     (1086H),L       ;߲ LSB 
         CP     A,0DH           ;ޭCHR = CR ?
         RET    NZ
         LD     (1088H),2       ;NEXT MD No
         RET
         ;
MDR12:   LD     A,(1089H)       ;RX DATA SAVE & CHK
         LD     XHL,1100H       ;߲ ް
         LD     L,(1086H)       ;߲ LSB
         LD     (XHL),A         ;ޭ - SAVE
         CP     A,0AH           ;ޭCHR = LF ?
         J      NZ,MD0SETR
         LD     BC,0            ;TX ޲  ¸
         LD     C,L             ;ޭ ޲  +1
         INC    1,BC            ;+1
         LD     (108AH),BC      ;SAVE TX byte CT
         LD     XHL,1100H       ;RXް TX BFF ݿ
         LD     XDE,1200H       ;TX BFF TOP
         LDIR
         LD     (1088H),0       ;MODE No 0
         SET    6,(100FH)       ;ޭݶخ FLG ON
         RET
MD0SETR: LD     (1088H),0       ;MODE No 0
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; AD ݶ Ͳ ݼ  64 ADݶ 
AD_AVE:  RES    5,(1050H)       ;A/D DATA READY FLG OFF
         LD     WA,(ADREG04L)   ;SAMP & ADD TOTAL BFF
         SRL    6,WA            ;SIFT DN 6bit
         ADD    (1040H),WA
         LD     WA,(ADREG15L)   ;SAMP & ADD TOTAL BFF
         SRL    6,WA            ;SIFT DN 6bit
         ADD    (1042H),WA
         DEC    1,(104EH)       ;DEC AD 
         RET    NZ
         ;
         LD     (104EH),64      ;AD  زƼ
         LD     XHL,1040H       ;COPY Ͳ BFF ->  BFF
         LD     XDE,1048H
         LD     BC,2
         LDIRW
         LDW    (1040H),0       ; BFF CLR
         LDW    (1042H),0
         J      AD_DSP
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; ADC DATA ˮ
         ; 64 ADݶ  64 BINARY/ASCII ݶ & ˮ
AD_DSP:  CP     (105AH),00H     ;ˮ ӰNo 00 ޲ RET
         RET    NZ              ;ADC ˮӰŲ
         LD     XBC,0           ;CLR
         LD     BC,(1048H)      ;ch0 ADݶ 64 
         DIV    XBC,64          ;64 /64
         LD     HL,QBC          ; CHK
         CP     HL,32           ;1/2  4  5ƭ
         CAL    NC,UP1BC        ;BC= 
         CAL    B_ASC4          ;IN BINARY=BC, OUT ASCII=1070H TOP
         LD     (1074H),00H     ;PUT NUL
         LD     A,38H           ;DDRAM ADDRESS
         LD     XHL,1070H       ;ADC DATA(ASCII) ˮ
         CAL    PRINT
         ;
         LD     XBC,0           ;CLR
         LD     BC,(104AH)      ;ch1 ADݶ 64 
         DIV    XBC,64          ;64 /64
         LD     HL,QBC          ; CHK
         CP     HL,32           ;1/2  4  5ƭ
         CAL    NC,UP1BC        ;BC= 
         CAL    B_ASC4          ;IN BINARY=BC, OUT ASCII=1070H TOP
         LD     (1074H),00H     ;PUT NUL
         LD     A,48H           ;DDRAM ADDRESS
         LD     XHL,1070H       ;ADC DATA(ASCII) ˮ
         CAL    PRINT
         RET
UP1BC:   INC    1,BC
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; - ƭخ ASCII- CHK
         ; Ӱƭخ, ƭخ, ƭخ  ܹ
KEYDATA: RES    2,(1050H)       ;ODR FLG OFF
         ;
         LD     A,(1057H)       ;CHK NEW DATA (ASCII)
         CP     A,'C'           ;"C" - "F" ?
         J      NC,MODEC        ;C1, C2, C3, C4
         CP     A,'A'           ;"A" - "B" ?
         J      NC,COMAND       ;SET, CLR
         ;    ƭخ 
         LD     W,(105AH)       ;ݻ޲ ˮ ӰNo CHK
         CP     W,30H           ;C4 ݹ Ӱ
         J      Z,NUM30         ;Ӱ30  ƭخ
         CP     W,20H           ;C3 ި 
         J      Z,NUM20         ;Ӱ20  ƭخ
         CP     W,10H           ;C2 F_ROM 
         J      Z,NUM10         ;Ӱ10  ƭخ
         CP     W,00H           ;C1 ADC خ
         J      Z,NUM00         ;Ӱ00  ƭخ
         RET
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; Ӱ10  ƭخ
         ;  & F_ROM BFF ƭخ Ӽަ 
NUM10:   CP     (105BH),50H     ; DD ADDRESS CHK
         CAL    NC,CUR_48       ;  48H SET
         LD     XDE,0           ;CLR
         LD     XHL,1090H       ;F_ROM BFF BASE
         LD     E,(105BH)       ; DD ADDRESS
         SUB    E,48H           ;  BASE 48H ˸
         ADD    XHL,XDE         ;F_ROM BFF BASE +  
         LD     A,(1057H)       ; ƭخ ް (ASCII)
         LD     (XHL),A         ; ƭخ ް 
         CAL    D_OUT           ; ƭخ ް ˮ
         RET
CUR_48:  LD     A,48H           ;  48H SET
         CAL    DDSET
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; Ӱ00  ƭخ
         ; Ӱ20  ƭخ
NUM00:
NUM20:
         RET
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; Ӱ30  ƭخ
NUM30:   LD     (1018H),11H     ;BZ MODE No ݹ Ӱ
         CP     (105BH),50H     ; DD ADDRESS CHK
         CAL    NC,CUR_40       ;  40H SET
         LD     A,(1057H)       ;CHK NEW DATA (ASCII)
         CP     A,'0'
         J      Z,L_SI          ; 
         CP     A,'1'
         J      Z,L_DO          ; 
         CP     A,'2'
         J      Z,M_RE          ;    
         CP     A,'3'
         J      Z,M_MI          ;    
         CP     A,'4'
         J      Z,M_FA          ;    ̧
         CP     A,'5'
         J      Z,M_SO          ;    
         CP     A,'6'
         J      Z,M_RA          ;    
         CP     A,'7'
         J      Z,M_SI          ;    
         CP     A,'8'
         J      Z,H_DO          ; 
         CP     A,'9'
         J      Z,H_RE          ; 
         RET
CUR_40:  LD     A,40H           ;  40H SET
         CAL    DDSET
         RET
         ;
L_SI:    LD     A,10110011B     ; 
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
L_DO:    LD     A,10110100B     ; 
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_RE:    LD     A,10110101B     ;    
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_MI:    LD     A,10110110B     ;    
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_FA:    LD     A,10110111B     ;    ̧
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_SO:    LD     A,10111000B     ;    
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_RA:    LD     A,10011001B     ;    
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
M_SI:    LD     A,10111010B     ;    
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
H_DO:    LD     A,10111011B     ; 
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
H_RE:    LD     A,10111100B     ; 
         CAL    f_SET           ;ݶ ò
         LD     A,''           ;ˮ Ӽ
         CAL    D_OUT           ;ˮ ް خ
         RET
         ;
         ; ݹ Ӱ޼ ޻ް OFF ݸ
ONGNCHK: CP     (1018H),11H     ;BZ MODE No CHK
         RET    NZ              ;ݹ Ӱ Ų
         AND    (TA67RUN),08H   ;TMRA67 STP & CLR, ޻ް OFF
         LD     (TA7FFCR),08H   ;TA7FF=CLR TA7FF=DISABLE
         LD     (1018H),00H     ;BZ MODE No ->00H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; Ӱƭخ C1, C2, C3, C4 Ӱ 
MODEC:   CP     A,'C'           ;C1 KEY IN
         J      Z,MD_C1
         CP     A,'D'           ;C2 KEY IN (ADC خ)
         J      Z,MD_C2
         CP     A,'E'           ;C3 KEY IN (ި )
         J      Z,MD_C3
         CP     A,'F'           ;C4 KEY IN (ݹ Ӱ)
         J      Z,MD_C4
         RET
         ;
         ; C4 KEY IN (ݹ Ӱ)
MD_C4:   LD     A,(105AH)       ;ݻ޲ ˮ ӰNo 
         AND    A,0F0H          ;MSB 4bit CHK
         CP     A,30H
         J      Z,BEEP          ; Ӱ 2X
         LD     (105AH),30H     ;ˮ ӰNo 30 Ľ
         CAL    D_CLR           ;ˮ CLR
         ;
         LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_ONGN     ;ݹ Ӱ ˮ
         CAL    PRINT
         LD     A,40H           ;DDRAM ADDRESS
         CAL    DDSET
         LD     A,39H           ;DISP ۰: C=1, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         RET
         ;
         ; C3 KEY IN  (ި )
MD_C3:   LD     A,(105AH)       ;ݻ޲ ˮ ӰNo 
         AND    A,0F0H          ;MSB 4bit CHK
         CP     A,20H
         J      Z,BEEP          ; Ӱ 2X
         LD     (105AH),20H     ;ˮ ӰNo 20 Ľ
         CAL    D_CLR           ;ˮ CLR
         LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_SENTK    ;ި  ˮ
         CAL    PRINT
         LD     A,39H           ;DISP ۰: C=1, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         LD     A,30H           ;DDRAM ADDRESS
         CAL    DDSET
         LD     (105CH),0       ;ݿ No=0
         RET
         ;
         ; C2 KEY IN  (F_ROM )
MD_C2:   LD     A,(105AH)       ;ݻ޲ ˮ ӰNo 
         AND    A,0F0H          ;MSB 4bit CHK
         CP     A,10H
         J      Z,BEEP          ; Ӱ 1X
MD_C21:  LD     (105AH),10H     ;ˮ ӰNo 10 Ľ
         CAL    D_CLR           ;ˮ CLR
         LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_FRM      ;F_ROM  DISP
         CAL    PRINT
         ;
         LD     XHL,(M_ADRS)    ;F_ROM   
         LD     XDE,1090H       ;F_ROM BFF TOP
         LD     BC,4
         LDIRW
         LD     (1098H),00H     ;PUT NUL
         LD     A,38H           ;DDRAM ADDRESS
         LD     XHL,1090H       ;F_ROM BFF TOP
         CAL    PRINT
         LD     A,48H           ;DDRAM ADDRESS
         LD     XHL,1090H       ;F_ROM BFF TOP
         CAL    PRINT
         LD     A,39H           ;DISP ۰: C=1, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         LD     A,48H           ;DDRAM ADDRESS
         CAL    DDSET
         ;
         RET
         ;
         ; C1 KEY IN  (ADC خ)
MD_C1:   LD     A,(105AH)       ;ݻ޲ ˮ ӰNo 
         AND    A,0F0H          ;MSB 4bit CHK
         CP     A,00H
         J      Z,BEEP          ; Ӱ 00
MD_C10:  LD     (105AH),00H     ;ˮ ӰNo 00 Ľ
         CAL    D_CLR           ;ˮ CLR
         ;
         LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_ADC      ;ADC خ DISP
         CAL    PRINT
         LD     A,31H           ;DISP ۰: C=0, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; ƭخ SET or CLR 
COMAND:  CP     A,'A'           ;SET KEY IN
         J      Z,SET_C
         CP     A,'B'           ;CLR KEY IN
         J      Z,CLR_C
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; SET  ƭخ
SET_C:   LD     W,(105AH)       ;ݻ޲ ˮ ӰNo CHK
         CP     W,10H           ;C2 (Ӱ10)
         J      Z,SET_10        ;F_ROM  ި Ӱ SET ƭخ
         CP     W,11H           ;C2 (Ӱ11)
         J      Z,SET_11        ;F_ROM ޯ Ӱ SET ƭخ
         CP     W,12H           ;C2 (Ӱ12)
         J      Z,SET_12        ;F_ROM  SET ƭخ
         CP     W,20H           ;C3 (Ӱ20)
         J      Z,CLR_20        ;ި  Ӱ SET ƭخ
         RET
         ;
         ; F_ROM  SET ƭخ
SET_12:  CP     (1021H),0       ;F_ROM ޮ ӰNo = ޮ
         RET    NZ              ;
         J      MD_C21          ;Ӱ10 ޽
         RET
         ;
         ; F_ROM ޯ Ӱ SET ƭخ
SET_11:  LD     (1021H),11H     ;F_ROM ޮ ˮ ӰNo11=
         LD     (105AH),12H     ;ˮ ӰNo 12 Ľ
         RET
         ;
         ; F_ROM  ި Ӱ SET ƭخ
SET_10:  LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_FRM1     ;F_ROM ޯ  ˮ
         CAL    PRINT
         LD     A,31H           ;DISP ۰: C=0, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         LD     (105AH),11H     ;ˮ ӰNo 11 Ľ
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; CLR  ƭخ
CLR_C:   LD     W,(105AH)       ;ݻ޲ ˮ ӰNo CHK
         CP     W,10H           ;C2 (Ӱ10)
         J      Z,CLR_10        ;F_ROM  ި Ӱ CLR ƭخ
         CP     W,11H           ;C2 (Ӱ11)
         J      Z,CLR_11        ;F_ROM ޯ Ӱ CLR ƭخ
         CP     W,20H           ;C3 (Ӱ20)
         J      Z,CLR_20        ;ި  Ӱ CLR ƭخ
         CP     W,30H           ;C4 (Ӱ20)
         J      Z,CLR_30        ;ݹ Ӱ CLR ƭخ
         RET
         ;
         ; F_ROM ޯ Ӱ CLR ƭخ
CLR_11:  J      MD_C21          ;Ӱ10 ޽
         RET
         ;
         ; F_ROM  ި Ӱ CLR ƭخ
         ;  ˮ& F_ROM BFF CLR
CLR_10:  LD     A,48H           ;DDRAM ADDRESS=2ޮ 9Ӽ
         LD     XHL,TB_BLK+24
         CAL    PRINT
         LD     A,48H           ;DDRAM =2ޮ 9Ӽ
         CAL    DDSET
         LD     XHL,TB_BLK+24   ;BLANK DISP TABLE
         LD     XDE,1090H       ;F_ROM BFF TOP
         LD     BC,4
         LDIRW
         RET
         ;
         ; ݿ ި   
CLR_20:  LD     W,(105BH)       ; DD ADDRESS CHK
         CP     W,30H
         J      Z,C20_30
         CP     W,38H
         J      Z,C20_38
         CP     W,40H
         J      Z,C20_40
         CP     W,48H
         J      Z,C20_48
         RET
         ; ݻ޲   30H
C20_30:  LD     A,38H           ;٦ 38Hƽ
         CAL    DDSET
         LD     (105CH),1       ;ݿ No=1
         RET
         ; ݻ޲   38H
C20_38:  LD     A,40H           ;٦ 40Hƽ
         CAL    DDSET
         LD     (105CH),2       ;ݿ No=2
         RET
         ; ݻ޲   40H
C20_40:  LD     A,48H           ;٦ 48Hƽ
         CAL    DDSET
         LD     (105CH),3       ;ݿ No=3
         RET
         ; ݻ޲   48H
C20_48:  LD     A,30H           ;٦ 30Hƽ
         CAL    DDSET
         LD     (105CH),0       ;ݿ No=0
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; Ӱ30 CLR ƭخ
CLR_30:  LD     A,40H           ;DDRAM ADDRESS=2ޮ TOP
         LD     XHL,TB_BLK+16
         CAL    PRINT
         LD     A,40H           ;DDRAM =2ޮ TOP
         CAL    DDSET
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 10msec 1 د ް 
KEYSCAN: RES    4,(1002H)       ;ODR FLG OFF
         CAL    PIICHK          ; د ݦ CHK
         ;
         LD     XHL,0           ;1ޮ  CHK 
         LD     A,11100000B     ;P2 DRV 
         CAL    KEYCHK          ;ò ޮ KEYد CHK  OUT:KEY DATA=W
         AND    W,0FH           ;KEY ƭخ  ?
         J      NZ,T_LAG        ; ޳  ׸ 
         ;
         LD     XHL,1           ;2ޮ  CHK 
         LD     A,11010000B     ;P2 DRV 
         CAL    KEYCHK          ;ò ޮ KEYد CHK  OUT:KEY DATA=W
         AND    W,0FH           ;KEY ƭخ  ?
         J      NZ,T_LAG        ; ޳  ׸ 
         ;
         LD     XHL,2           ;3ޮ  CHK 
         LD     A,10110000B     ;P2 DRV 
         CAL    KEYCHK          ;ò ޮ KEYد CHK  OUT:KEY DATA=W
         AND    W,0FH           ;KEY ƭخ  ?
         J      NZ,T_LAG        ; ޳  ׸ 
         ;
         LD     XHL,3           ;4ޮ  CHK 
         LD     A,01110000B     ;P2 DRV 
         CAL    KEYCHK          ;ò ޮ KEYد CHK  OUT:KEY DATA=W
         AND    W,0FH           ;KEY ƭخ  ?
         J      NZ,T_LAG        ; ޳  ׸ 
         ;
         BIT    0,(1050H)       ;KEY ONޮ FLG CHK
         RET    Z               ;ON Ų
         BIT    1,(1050H)       ;KEY ON -> OFF ݶ FLG CHK
         J      NZ,K_OFF        ;ݶ
         SET    1,(1050H)       ;KEY ON -> OFF ݶ FLG ON
         RET
K_OFF:   RES    0,(1050H)       ;KEY ONޮ FLG OFF
         RES    1,(1050H)       ;KEY ON -> OFF ݶ FLG OFF
         CAL    ONGNCHK         ;ݹ Ӱ޼ ޻ް OFF ݸ
         RET
         ;
         ; IN:SCAN LINE -1=XHL  OUT:KEY DATA=W
KEYCHK:  LD     (1051H),L       ;SCAN LINE 
         LD     (P2),A
         NOP
         LD     W,(P5)          ;KEY DATA IN
         CPL    W
         SRL    4,W             ;KEY DATA=----DDDD
         LD     (P2),0F0H       ;SCAN LINE OFF
         RET
         ;
         ;  ޳ ݶ KEYް  10msecϴ KEYް ˶
         ; IN:SCAN LINE -1=XHL  IN:KEY DATA=W
T_LAG:   BIT    0,(1050H)       ;KEY ONޮ FLG CHK
         RET    NZ              ; ON
         ADD    XHL,1052H       ;KEYް ӱڽ=1052H+ײ -1
         CP     (XHL),W         ;10msecϴ KEYް - ݶ KEYް
         J      Z,TRUE          ;2ݿ޸ ż  ݼ
         LD     (XHL),W         ;ݶ KEYް 
         RET
         ;
         ; 2ݿ޸ ż  òļ ASCIIް ¹
TRUE:    SET    0,(1050H)       ;KEY ONޮ FLG ON
         SET    2,(1050H)       ;KEY DATA READY FLG ON
         CAL    PIISET          ; د ݦ SET
         LD     XHL,1057H       ;KEY DATA(ASCII) SAVE SDDRESS
         LD     A,(1051H)       ;SCAN LINE MEMO CHK
         CP     A,0             ;LINE 1 ?
         J      Z,L1CHK
         CP     A,1             ;LINE 2 ?
         J      Z,L2CHK
         CP     A,2             ;LINE 3 ?
         J      Z,L3CHK
         CP     A,3             ;LINE 4 ?
         J      Z,L4CHK
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; SCAN LINE "1" CHECK
         ; IN:W=KEYް,  IN:XHL=SCAN LINE MEMO
L1CHK:   CP      W,01H          ;C1
         J       Z,CHR_C
         CP      W,02H          ;0
         J       Z,CHR_0
         CP      W,04H          ;CLEAR
         J       Z,CHR_B
         CP      W,08H          ;SET
         J       Z,CHR_A
         RET
CHR_A:   LD     (XHL),'A'
         RET
CHR_B:   LD     (XHL),'B'
         RET
CHR_0:   LD     (XHL),'0'
         RET
CHR_C:   LD     (XHL),'C'
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; SCAN LINE "2" CHECK
L2CHK:   CP      W,01H          ;C2
         J       Z,CHR_D
         CP      W,02H          ;1
         J       Z,CHR_1
         CP      W,04H          ;2
         J       Z,CHR_2
         CP      W,08H          ;3
         J       Z,CHR_3
         RET
CHR_3:   LD     (XHL),'3'
         RET
CHR_2:   LD     (XHL),'2'
         RET
CHR_1:   LD     (XHL),'1'
         RET
CHR_D:   LD     (XHL),'D'
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; SCAN LINE "3" CHECK
L3CHK:   CP      W,01H          ;C3
         J       Z,CHR_E
         CP      W,02H          ;4
         J       Z,CHR_4
         CP      W,04H          ;5
         J       Z,CHR_5
         CP      W,08H          ;6
         J       Z,CHR_6
         RET
CHR_6:   LD     (XHL),'6'
         RET
CHR_5:   LD     (XHL),'5'
         RET
CHR_4:   LD     (XHL),'4'
         RET
CHR_E:   LD     (XHL),'E'
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;
         ; SCAN LINE "4" CHECK
L4CHK:   CP      W,01H          ;C4
         J       Z,CHR_F
         CP      W,02H          ;7
         J       Z,CHR_7
         CP      W,04H          ;8
         J       Z,CHR_8
         CP      W,08H          ;9
         J       Z,CHR_9
         RET
CHR_9:   LD     (XHL),'9'
         RET
CHR_8:   LD     (XHL),'8'
         RET
CHR_7:   LD     (XHL),'7'
         RET
CHR_F:   LD     (XHL),'F'
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; BUZZER CONTROL (BEEP, Pii)
PIISET:  CP     (1018H),00H     ; د ݦ SET, BZ MODE No CHK
         RET    NZ              ;BUZZER خ 
         CP     (105AH),30H     ;C4 ݹ Ӱ
         RET    Z
         LD     (1018H),10H     ;BZ MODE No -> BEEPӰ
         LD     (1060H),2       ;Pi TIM=20msec
BZON:    AND    (TA67RUN),08H   ;TMRA67 STP & CLR
         LD     (TA67MOD),83H   ;PPG MODE, clk=T16
         LD     (TA6REG),25     ;DUTY SET  50%
         LD     (TA7REG),50     ;CYCLE SET  3840Hz
         LD     (TA7FFCR),06H   ;TA7FF=SET TA7FF=ENABLE
         OR     (TA67RUN),07H   ;TMRA67 START
         RET
         ;
BEEP:    CP     (1018H),11H     ;BZ MODE No CHK
         RET    Z               ;ݹ خ 
         LD     (1018H),10H     ;BZ MODE No -> BEEPӰ
         LD     (1060H),40      ;BEEP TIM=400msec
         J      BZON            ;BEEP ON
         RET
         ;
PIICHK:  CP     (1018H),10H     ;BZ MODE No CHK
         RET    NZ              ;BUZZER خ 
         CP     (1060H),0       ;Pi TIM CHK
         RET    NZ
BZOFF:   AND    (TA67RUN),08H   ;TMRA67 STP & CLR
         LD     (TA7FFCR),08H   ;TA7FF=CLR TA7FF=DISABLE
         LD     (1018H),00H     ;BZ MODE No ->00H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; BUZZER CONTROL (ݹ)
BUZZER:  CP     (1018H),0       ;BZ MODE No CHK
         RET    Z
         CP     (1060H),0       ;INH TIM CHK
         RET    NZ              ; 
         LD     A,(1018H)       ;BZ MODE No CHK
         CP     A,01H           ;ި TABLE į߶ ʼ
         J      Z,BZ_MD1
         CP     A,02H           ;ި TABLE 2byteҶ END ݿ޸ 
         J      Z,BZ_MD2
         CP     A,0FH           ;1 ODR NUL ݼº 
         J      Z,BZ_MDF
         RET
         ;
         ; 1 ODR NUL ݼº 
BZ_MDF:  LD     XHL,(101CH)     ;ݻ޲ TABLE ߲
         LD     A,(XHL+)
         LD     (101CH),XHL     ;߲ 
         CP     A,00H           ;NUL CHK
         J      Z,BZ_END        ;2ݿ޸ NUL END
         CAL    LENGS           ; Ŷ޻ ò
         CAL    f_SET           ;ݶ ò
         LD     (1018H),2       ;MODE No=2
         RET
         ; 2ݿ޸ NUL END
BZ_END:  LD     (1018H),0       ;MODE No=0
         RET
         ;
         ; ި TABLE 2byteҶ END ݿ޸ 
BZ_MD2:  LD     XHL,(101CH)     ;ݻ޲ TABLE ߲
         LD     A,(XHL+)
         LD     (101CH),XHL     ;߲ 
         CP     A,00H           ;NUL CHK
         J      Z,BZFSET        ;END ݼ Ӱ
         CAL    LENGS           ; Ŷ޻ ò
         CAL    f_SET           ;ݶ ò
         RET
         ;
         ; ި TABLE į߶ ʼ
BZ_MD1:  CAL    SEL_TBL         ;ݿ   ð٦ ޽
         LD     A,(XHL+)
         LD     (101CH),XHL     ;߲ 
         CP     A,00H           ;NUL CHK
         J      Z,BZFSET        ;END ݼ Ӱ
         CAL    LENGS           ; Ŷ޻ ò
         CAL    f_SET           ;ݶ ò
         LD     (1018H),2       ;MODE No=2
         RET
         ;
         ; ݿ   ð٦ ޽
SEL_TBL: LD     W,(105CH)       ;ݿ No ODR CHK
         CP     W,0
         J      Z,MUSIC0
         CP     W,1
         J      Z,MUSIC1
         CP     W,2
         J      Z,MUSIC2
         CP     W,3
         J      Z,MUSIC3
         RET
MUSIC0:  LD     XHL,TB_HARU     ;ި TABLE=ٶ޷
         RET
MUSIC1:  LD     XHL,TB_TULIP    ;ި TABLE=د
         RET
MUSIC2:  LD     XHL,TB_BZ       ;ި TABLE=̧
         RET
MUSIC3:  LD     XHL,TB_BZ       ;ި TABLE=̧
         RET
         ;
         ; ODR= NUL ķ 
BZFSET:  CAL    LENGS           ; Ŷ޻ ò
         AND    (TA67RUN),08H   ;TMRA67 STP & CLR
         LD     (TA7FFCR),08H   ;TA7FF=CLR TA7FF=DISABLE
         LD     (1018H),0FH     ;END ݼ Ӱ 
         RET
         ;
         ; ݶ ò  IN:A=ð Ųֳ
f_SET:   LD     XBC,0           ;CLR
         LD     C,A             ;COPY
         AND    C,0FH
         LD     XHL,ONKAI       ;ݶ ð į
         ADD    XHL,XBC         ;ݶ ð į+ ݶ ODR No
         LD     W,(XHL)         ;7 ò
         AND    (TA67RUN),08H   ;TMRA67 STP & CLR
         LD     (TA67MOD),83H   ;PPG MODE, clk=T16
         LD     (TA7REG),W      ;CYCLE SET
         CAL    GAIN            ;  
         LD     (TA6REG),W      ;DUTY SET
         LD     (TA7FFCR),06H   ;TA7FF=SET TA7FF=ENABLE
         OR     (TA67RUN),07H   ;TMRA67 START
         RET
         ;
         ;   
GAIN:    SRL    1,W             ;DUTY CYCLE/2Ľ
         SRL    4,A             ;  ODR CHK
         AND    A,03H
         CP     A,03H           ;ODR DUTY 1/2
         RET    Z
         SRL    1,W             ;DUTY CYCLE/4Ľ
         CP     A,02H           ;ODR DUTY 1/4
         RET    Z
         SRL    1,W             ;DUTY CYCLE/8Ľ
         CP     A,01H           ;ODR DUTY 1/8
         RET    Z
         LD     W,1             ; = min
         RET
         ;  Ŷ޻ ò  IN:A=ð Ųֳ
LENGS:   LD     W,A             ;COPY
         AND    W,0C0H          ; Ŷ޻ òbit CHK
         CP     W,0C0H          ;1000msec odr ?
         J      Z,Ln1000
         CP     W,80H           ;750msec odr ?
         J      Z,Ln750
         CP     W,40H           ;500msec odr ?
         J      Z,Ln500
         CP     W,00H           ;250msec odr ?
         J      Z,Ln250
         RET
Ln1000:  LD     (1060H),100     ;10msec* n TIMER <- 100
         RET
Ln750:   LD     (1060H),75      ;10msec* n TIMER <- 75
         RET
Ln500:   LD     (1060H),50      ;10msec* n TIMER <- 50
         RET
Ln250:   LD     (1060H),25      ;10msec* n TIMER <- 25
         RET
         ;
T67SET:  AND    (TA67RUN),08H   ;TMRA67 STP & CLR
         LD     (TA67MOD),83H   ;PPG MODE, clk=T16
         LD     (TA6REG),33      ;DUTY SET
         LD     (TA7REG),66     ;CYCLE SET
         LD     (TA7FFCR),06H   ;TA7FF=SET TA7FF=ENABLE
         OR     (TA67RUN),07H   ;TMRA67 START
         LD     (1018H),2       ;MODE No=2
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; MODE No(1021H)=1xH  RAMŲٰ (1020H) 
         ; (1021H)=00H=
         ; (1021H)=11H=  CHK   ߲ JP -(SCT_FUL)
         ;                             ɳ  JP (FR_125)
         ; (1021H)=12H=-  (FR_125)
         ; (1021H)=13H= 
F_CONT:  LD     A,(1021H)       ;F_ROM ޮ ӰNo CHK
         CP     A,11H
         J      Z,F_WR11        ;  CHK & JP - or 
         CP     A,12H
         J      Z,F_WR12        ;  - &  ò
         CP     A,13H
         J      Z,F_WR13        ;  &  خ ˮ
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; ò  CHK & JP - or 
F_WR11:  CP     (1020H),0       ;F_ROM ON DUTY ?
         RET    NZ
         LD     XHL,(M_ADRS)    ;  CHK
         CP     XHL,0FFBFF0H    ;߲ 
         J      NC,SCT_FUL
         INC    8,XHL           ;·  خ CHK
         LD     (M_ADRS),XHL
         LD     XBC,(XHL)       ;F_ROMŲ= FFFFFFFFH ?
         CP     XBC,0FFFFFFFFH
         J      NZ,SCT_FUL
         INC    4,XHL
         LD     XBC,(XHL)       ;F_ROMŲ= FFFFFFFFH ?
         CP     XBC,0FFFFFFFFH
         J      NZ,SCT_FUL
         J      F_WR125         ; ò
         RET
         ;
         ; 5 - ʯ,  ڽ ؾ
SCT_FUL: LD     (1020H),15H     ;5 - ODR
         LD     (1021H),12H     ;F_ROM ޮ ӰNo12 =5 - 
         LD     XHL,0FFA000H    ; ڽ ؾ
         LD     (M_ADRS),XHL
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; F_ROM  -  &  ò
F_WR12:  CP     (1020H),0       ;F_ROM ON DUTY ?
         RET    NZ
F_WR125: LD     XHL,(M_ADRS)    ;F_ROM SAVE  
         LD     (F_TO),XHL
         LD     XHL,1090H       ;F_ROM BFF TOP
         LD     (F_FROM),XHL
         LD     XHL,4           ;word CT
         LD     (F_CT),XHL
         LD     (1020H),30H     ;5  ODR
         LD     (1021H),13H     ;F_ROM ޮ ӰNo13 = 
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ;   &  خ ˮ
F_WR13:  CP     (1020H),0       ;F_ROM ON DUTY ?
         RET    NZ
         LD     (1021H),0       ;F_ROM ޮ ӰNo =
         LD     A,30H           ;DDRAM ADDRESS
         LD     XHL,TB_FRM2     ;F_ROM خ ˮ
         CAL    PRINT
         LD     A,31H           ;DISP ۰: C=0, B=0, RE=0, D=1
         CAL    C_OUT           ; خ
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; CALL 1sec TRIG from MAIN ROUTINE
TIM1S:   RES    0,(1006H)       ;1sec FLG OFF
         LD     XHL,106CH       ;TIM BFF TOP
         LD     W,4             ;TIM BFF 
         LD     A,0             ;DEC 
         CAL    AUX_T           ;DEC TIMER

         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; CALL  100msec TRIG from MAIN ROUTINE
TIM100:  RES    0,(1004H)       ;100msec FLG CHK
         LD     XHL,1068H       ;TIM BFF TOP
         LD     W,4             ;TIM BFF 
         LD     A,0             ;DEC 
         CAL    AUX_T           ;DEC TIMER
         CAL    DBG_TOL         ;DIP SW CHK & ޯ ° ޳
         ;
         RET
         ;
         ; DIP SW CHK & ޯ ° ޳
DBG_TOL: BIT    2,(100FH)       ;ر ݿ FLG CHK
         RET    NZ              ;ݿ
         CP     (100AH),0       ; 1byte خ 
         RET    NZ
         BIT    0,(P4FIX)       ;DIP 3 CHK
         J      Z,TSTDSP        ;ڼ޽ ˮ
         BIT    3,(P5FIX)       ;DIP 2 CHK
         J      Z,DUMP_UP
         BIT    2,(P5FIX)       ;DIP 1 CHK
         J      Z,DUMP_DN
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; CALL  10msec TRIG from MAIN ROUTINE
TIM10:   RES    2,(1002H)       ;1.25*8=10msec FLG
         LD     XHL,1060H       ;TIM BFF TOP
         LD     W,4             ;TIM BFF 
         LD     A,0             ;DEC 
         CAL    AUX_T           ;DEC TIMER
         ;
         INC    1,(PA)          ;8bit LED ˮ INC
         BIT    4,(P7)          ;P74  ƭخ CHK
         CAL    Z,BZ_STAT       ;޳ ݿ BUZZER START SET
         CAL    BUZZER          ;ݹ ޻ް ۰

         RET
         ;
         ; ޳ ݿ BUZZER START SET
BZ_STAT: CP     (1018H),0       ;BZ MODE No CHK
         RET    NZ              ;BUZZER خ 
         LD     (1018H),1       ;MODE No -> 1
         RET
         ;
         ; BFF 0  ò޶ DEC
AUX_T:   CP      A,(XHL)
         J       Z,LVAUX
         DEC     1,(XHL)
LVAUX:   INC     1,XHL          ;NEXT POINTER
         DEC     1,W
         J       NZ,AUX_T
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 10msec ROUTINE
         ;  ƭخ ݸ ޳
PSCAN:   RES    0,(1002H)       ;1.25*8=10msec FLG OFF
         CAL    P7SCAN
         CAL    P5SCAN
         CAL    P4SCAN
         RET
         ;
P4SCAN:  LD     A,(P4)          ;SW DATA IN
         AND    A,01H           ;CUT UNUSE bit ----0001
         CP     A,(P4M)         ;CP LAST DATA
         JP     Z,TRUE_4
         LD     (P4M),A         ;to MEMO
         RET
TRUE_4:  LD     (P4FIX),A       ;to P5FIX
         RET
         ;
P5SCAN:  LD     A,(P5)          ;SW DATA IN
         AND    A,0CH           ;CUT UNUSE bit 00001100
         CP     A,(P5M)         ;CP LAST DATA
         JP     Z,TRUE_5
         LD     (P5M),A         ;to MEMO
         RET
TRUE_5:  LD     (P5FIX),A       ;to P5FIX
         RET
         ;
P7SCAN:  LD     A,(P7)          ;SW DATA IN
         AND    A,10H           ;CUT UNUSE bit 00010000
         CP     A,(P7M)         ;CP LAST DATA
         JP     Z,TRUE_7
         LD     (P7M),A         ;to MEMO
         RET
TRUE_7:  LD     (P7FIX),A       ;to P7FIX
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; Sڼ޽ASCIIϊRS-232C֏o͂
         ; FORMAT:XWA  76543210CR.LF
TSTDSP:  ; gpobt@= (TEMP - 2) -> 148 byte
REGDSP:  LD     (TEMP+15),XWA   ;ڼ޽ -
         LD     (TEMP+30),XBC
         LD     (TEMP+45),XDE
         LD     (TEMP+60),XHL
         LD     (TEMP+75),XIX
         LD     (TEMP+90),XIY
         LD     (TEMP+105),XIZ
         LD     (TEMP+120),XSP
         PUSH   SR
         POPW   (TEMP+135)
         LDW    (TEMP+137),0    ;CLEAR SR - byte
         ;
         PUSH   XWA             ;ڼ޽ ޔ
         PUSH   XBC
         PUSH   XDE
         PUSH   XHL
         CAL    CHG_TX          ;ASCIIϊ & RS232C]
         POP    XHL             ;ڼ޽A
         POP    XDE
         POP    XBC
         POP    XWA
         RET
         ;
CHG_TX:  LD     XBC,4           ;XSPlCAL ␳
         ADD    (TEMP+120),XBC
         LD     XHL,TEMP+15     ;XWA START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+30     ;XBC START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+45     ;XDE START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+60     ;XHL START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+75     ;XIX START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+90     ;XIY START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+105    ;XIZ START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+120    ;XSP START ADDRESS
         CAL    CHGASC1
         LD     XHL,TEMP+135    ;SR  START ADDRESS
         CAL    CHGASC1
         ;
         LD     BC,5            ;ͯ ] XWA
         LD     XDE,TEMP        ;TO ADDRES
         LD     XHL,H_XWA       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XBC
         LD     XDE,TEMP+15     ;TO ADDRES
         LD     XHL,H_XBC       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XDE
         LD     XDE,TEMP+30     ;TO ADDRES
         LD     XHL,H_XDE       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XHL
         LD     XDE,TEMP+45     ;TO ADDRES
         LD     XHL,H_XHL       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XIX
         LD     XDE,TEMP+60     ;TO ADDRES
         LD     XHL,H_XIX       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XIY
         LD     XDE,TEMP+75     ;TO ADDRES
         LD     XHL,H_XIY       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XIZ
         LD     XDE,TEMP+90     ;TO ADDRES
         LD     XHL,H_XIZ       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] XSP
         LD     XDE,TEMP+105    ;TO ADDRES
         LD     XHL,H_XSP       ;FROM ADDRESS
         LDIR
         ;
         LD     BC,5            ;ͯ ] SR
         LD     XDE,TEMP+120    ;TO ADDRES
         LD     XHL,H_SR        ;FROM ADDRESS
         LDIR
         ;
         LD     XHL,TEMP-2      ;PUT DUMMY CR,LF
         LDW    (XHL),0A0DH
         LD     XHL,TEMP-2        ;] ADDRESS TOP
         LD     BC,137
         CAL    TXSIO1
         RET
         ;
CHGASC1: LD     XDE,XHL         ;MAKE SAVE ADDRESS TOP
         SUB    XDE,10
         ADD    XHL,3
         LD     W,4             ;LOOP COUNTER
LP_001:  LD     A,(XHL)         ;LOAD HEX CAHR
         CAL    HACHG           ;IN HEX=A, OUT ASCII=BC
         LD     (XDE),B         ;SAVE ASCII CHAR
         INC    1,XDE
         LD     (XDE),C
         INC    1,XDE
         DEC    1,XHL
         DEC    1,W
         J      NZ,LP_001
         LDW    (XDE),0A0DH     ;CR,LF
         RET
         ;
         ; ]ͯ
H_XWA    DB     "XWA  "
H_XBC    DB     "XBC  "
H_XDE    DB     "XDE  "
H_XHL    DB     "XHL  "
H_XIX    DB     "XIX  "
H_XIY    DB     "XIY  "
H_XIZ    DB     "XIZ  "
H_XSP    DB     "XSP  "
H_SR     DB     "SR   "
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; XHL:Ӽ ĳ ڽ
         ; BC :Ӽ Ŷ޻ MAX=65K
         ; ò ޮ:BC -> 0
         ; ֳSIO:SIO_0   ֳDMA:HDMA_0
TXSIO0:  LDC    DMAS0,XHL       ;- - ڽ
         LD     XDE,SC0BUF
         LDC    DMAD0,XDE       ;SIO ޯ̧ ڽ
         LDC    DMAC0,BC        ;
         LD     E,08H
         LDC    DMAM0,E         ; -> I/O ݸ ޲ ݿ
         LD     (INTCLR),22H    ;TX0 INT FLG CLR
         LD     (DMA0V),22H     ;SIO TX0 ޸
         LD     (DMAR),01H      ;DMA 0 START
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; XHL:Ӽ ĳ ڽ
         ; BC :Ӽ Ŷ޻ MAX=65K
         ; ò ޮ:BC -> 0
         ; ֳSIO:SIO_1   ֳDMA:HDMA_1
TXSIO1:  LDC    DMAS1,XHL       ;- - ڽ
         LD     XDE,SC1BUF
         LDC    DMAD1,XDE       ;SIO ޯ̧ ڽ
         LDC    DMAC1,BC        ;
         LD     E,08H
         LDC    DMAM1,E         ; -> I/O ݸ ޲ ݿ
         LD     (INTCLR),24H    ;TX1 INT FLG CLR
         LD     (DMA1V),24H     ;SIO TX1 ޸
         LD     (DMAR),02H      ;DMA1 SOFT START
         LD     (INTETC01),40H
         SET    2,(100FH)       ;ر ݿ FLG ON
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; RS232C 20Hbyte خ & ڽ 20H 
DUMP_UP: CAL    DUMP
         LD     XHL,(M_POINT)
         ADD    XHL,20H
         LD     (M_POINT),XHL
         RET
DUMP_DN: CAL    DUMP
         LD     XHL,(M_POINT)
         SUB    XHL,20H
         LD     (M_POINT),XHL
         RET
         ;
         ; RAM DATA  ݶݺ RS232C خ
         ; (M_POINT) 20H ޲   ̫ϯ = ڽ + -
DUMP:    LD     XDE,TEMP        ;ޯ̧ TOP
         LD     XHL,M_POINT+3
         LD     W,4
LP_REC1: LD     A,(XHL)
         CALL   HACHG           ;Hex -> ASC  IN:Hex=A  OUT:ASCII=BC
         LD     (XDE),B
         INC    1,XDE
         LD     (XDE),C
         INC    1,XDE
         DEC    1,XHL
         DEC    1,W
         J      NZ,LP_REC1
         LD     (XDE),20H       ;-
         INC    1,XDE
         ;
         LD     XHL,(M_POINT)
         LD     W,10H
LP_REC2: LD     A,(XHL)
         CALL   HACHG           ;Hex -> ASC  IN:Hex=A  OUT:ASCII=BC
         LD     (XDE),B
         INC    1,XDE
         LD     (XDE),C
         INC    1,XDE
         INC    1,XHL
         DEC    1,W
         J      NZ,LP_REC2
         LD     (XDE),20H       ;-
         INC    1,XDE
         ;
         LD     W,10H
LP_REC3: LD     A,(XHL)
         CALL   HACHG           ;Hex -> ASC  IN:Hex=A  OUT:ASCII=BC
         LD     (XDE),B
         INC    1,XDE
         LD     (XDE),C
         INC    1,XDE
         INC    1,XHL
         DEC    1,W
         J      NZ,LP_REC3
         LDW    (XDE),0A0DH     ;CR LF
         ;
         LD     BC,76           ; (20Hbyte * 2)+12-1
         LD     XHL,TEMP        ;ر  ߲ 
         J      TXSIO1          ;ر  DMA ޳
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; RAM DATA  ݶݺ RS232C خ
         ; IN:XHL=RAM TOP, IN:W  =ݿ byte
         ; LD     XHL,87FF00H
         ; LD     W,20
         ; CAL    RAMDSP
RAMDSP:  LD     XDE,TEMP        ;ޯ̧ TOP
         PUSH   WA              ; 
LP_REC:  LD     A,(XHL)
         CALL   HACHG           ;Hex -> ASC  IN:Hex=A  OUT:ASCII=BC
         LD     (XDE),B
         INC    1,XDE
         LD     (XDE),C
         INC    1,XDE
         INC    1,XHL
         DEC    1,W
         J      NZ,LP_REC
         LDW    (XDE),0A0DH     ;0D0AH     ;CR LF
         POP    WA              ; 
         LD     B,0             ;CLR
         LD     C,W             ; = (W * 2)+2
         SLL    1,BC            ;*2
         ADD    BC,2            ;ر  byte 
         LD     XHL,TEMP        ;ر  ߲ 
         J      TXSIO1          ;ر  DMA ޳
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 6 ASCII -> BINARY ݶ
         ; IN: DISP TOP ADD=XHL (ASCII) *6
         ; OUT: BINARY=XBC
A_BIN6:  LD     A,(XHL)         ;LOAD TOP DATA
         CAL    SUUJI
         LD     B,A
         INC    1,XHL           ;LOAD 2nd DATA
         LD     A,(XHL)
         CAL    SUUJI
         LD     C,A
         INC    1,XHL
         CAL    AHCHG           ;ASCII HEX CHG IN:BC OUT:A
         LD     D,A             ;BRIEF SAVE
         ;
         LD     A,(XHL)         ;LOAD 3rd DATA
         CAL    SUUJI
         LD     B,A
         INC    1,XHL           ;LOAD 4th DATA
         LD     A,(XHL)
         CAL    SUUJI
         LD     C,A
         CAL    AHCHG           ;ASCII HEX CHG IN:BC OUT:A
         LD     E,A             ;BRIEF SAVE
         ;
         INC    1,XHL
         LD     A,(XHL)         ;LOAD 5rd DATA
         CAL    SUUJI
         LD     B,A
         INC    1,XHL           ;LOAD 6th DATA
         LD     A,(XHL)
         CAL    SUUJI
         LD     C,A
         CAL    AHCHG           ;ASCII HEX CHG IN:BC OUT:A
         LD     C,A             ;BCD DATA LSB
         LD     B,E
         LD     QBC,0           ;CLR
         LD     QC,D
         ;
BCDBIN6: LD     XHL,0           ;IN:BCD=XBC (MAX 999999) OUT:BINARY=XBC
         LD     A,QC            ;SUM 100000
         SRL    4,A
         LD     XDE,100000
         CAL    SUMADD6         ;ADD (1000 * n)
         LD     A,QC            ;SUM 10000
         AND    A,0FH           ;CUT UPPER
         LD     XDE,10000
         CAL    SUMADD6         ;ADD (100 * n)
         ;
         LD     A,B             ;SUM 1000
         SRL    4,A
         LD     XDE,1000
         CAL    SUMADD6         ;ADD (1000 * n)
         LD     A,B             ;SUM 100
         AND    A,0FH           ;CUT UPPER
         LD     XDE,100
         CAL    SUMADD6          ;ADD (100 * n)
         ;
         LD     A,C             ;SUM 10
         SRL    4,A
         LD     XDE,10
         CAL    SUMADD6         ;ADD (10 * n)
         AND    XBC,0000000FH   ;SUM 1 CUT UPPER
         ADD    XBC,XHL
         RET
         ;
         ; XHL+(KETA : n)
SUMADD6: CP     A,0             ;n CT CHECK
         RET    Z
         ADD    XHL,XDE
         DEC    1,A
         J      SUMADD6
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 4 ASCII -> BINARY ݶ
         ; IN: DISP TOP ADD=XHL (ASCII) *4
         ; OUT: BINARY=BC
A_BIN4:  LD     A,(XHL)         ;LOAD TOP DATA
         CAL    SUUJI
         LD     B,A
         INC    1,XHL           ;LOAD 2nd DATA
         LD     A,(XHL)
         CAL    SUUJI
         LD     C,A
         INC    1,XHL
         CAL    AHCHG           ;IN ASCII=BC, OUT HEX=A
         LD     D,A             ;BRIEF SAVE
         LD     A,(XHL)         ;LOAD 3rd DATA
         CAL    SUUJI
         LD     B,A
         INC    1,XHL            ;LOAD 4th DATA
         LD     A,(XHL)
         CAL    SUUJI
         LD     C,A
         CAL    AHCHG           ;ASCII HEX CHANGE
         LD     C,A             ;BCD DATA (LSB)
         LD     B,D             ;BCD DATA (MSB)
BCDBIN4: LD     HL,0000H        ;IN:BCD=BC (MAX 9999) OUT:BINARY=BC
         LD     A,B             ;SUM 1000
         SRL    4,A
         LD     DE,1000
         CAL    SUMADD          ;ADD (1000 * n)
         LD     A,B             ;SUM 100
         AND    A,0FH           ;CUT UPPER
         LD     DE,100
         CAL    SUMADD          ;ADD (100 * n)
         LD     A,C             ;SUM 10
         SRL    4,A
         LD     DE,10
         CAL    SUMADD          ;ADD (10 * n)
         AND    BC,000FH        ;SUM 1 CUT UPPER
         ADD    HL,BC
         LD     BC,HL
         RET
         ;
         ; HL+(KETA : n)
SUMADD:  CP     A,0             ;n CT CHECK
         J      Z,SUMRET
         ADD    HL,DE
         DEC    1,A
         J      SUMADD
SUMRET:  RET
         ;
         ; ޲޲ (30H > X >39H) 30H 
SUUJI:   CP     A,30H           ;X < 30H
         J      C,LVSU6
         CP     A,3AH           ;X < 3AH
         RET    C
LVSU6:   LD     A,30H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; ASCII HEX CHANGE
         ; IN ASCII=BC, OUT HEX=A
AHCHG:   LD     A,C             ;1st LOW NIBLE
         CAL    ABSUB
         RET    C
         LD     C,A             ;BREEF SAVE
         LD     A,B             ;2nd UPPER NIBLE
         CAL    ABSUB
         RET    C
         SLA    4,A             ;SIFT UP 4bit
         OR     A,C             ;MIXED
         RET
         ;
ABSUB:   CP     A,30H           ;LESS THAN 30H ?
         RET    C
         CP     A,3AH
         J      C,UPCL
         CP     A,41H           ;LES THAN A ?
         RET    C
         CP     A,47H
         CCF
         RET    C
         ADD    A,09H
UPCL:    AND    A,0FH
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 6 BINARY -> ASCII ݶ
         ; IN BINARY=XBC  (MAX = 999999)
         ; OUT ASCII=1070H TOP
B_ASC6:  CAL    BINBCD6         ;IN=XBC OUT=XBC
         LD     (CB2),BC        ;X4-3=CB3 X2-1=CB2
         LD     A,QC
         CAL    HACHG           ;HEX=A ASCII=BC
         LD     XHL,1070H       ;SAVE X5 ASCII
         LD     (XHL),B
         INC    1,XHL           ;SAVE X4 ASCII
         LD     (XHL),C
         LD     A,(CB2+1)
         CAL    HACHG           ;HEX=A ASCII=BC
         LD     XHL,1072H       ;SAVE X3 ASCII
         LD     (XHL),B
         INC    1,XHL           ;SAVE X2 ASCII
         LD     (XHL),C
         LD     A,(CB2)
         CAL    HACHG           ;HEX=A ASCII=BC
         LD     XHL,1074H       ;SAVE X1 ASCII
         LD     (XHL),B
         INC    1,XHL           ;SAVE X0 ASCII
         LD     (XHL),C
         INC    1,XHL           ;SAVE NUL
         LD     (XHL),00H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;
         ; BINARY BCD CHANGE
         ; IN:BINARY=XBC(MAX 999999)  OUT:BCD=XBC
BINBCD6: CP     XBC,999999      ;MAX CHK
         CAL    NC,PUT09M
         ;
         LD     XIX,100000      ;MAKE SUM 100000
         LD     A,0             ;CLR
         CAL    KnSUB6          ;BC - DE & INC A
         SLA    4,A             ;4 SIFT UP
         LD     D,A             ;MEMO MSB
         LD     XIX,10000       ;MAKE SUM 10000
         LD     A,0             ;CLR
         CAL    KnSUB6          ;BC - DE & INC A
         AND    A,0FH
         OR     D,A             ;D5,D4 in D
         ;
         LD     XIX,1000        ;MAKE SUM 1000
         LD     A,0             ;CLR
         CAL    KnSUB6          ;BC - DE & INC A
         SLA    4,A             ;4 SIFT UP
         LD     E,A             ;MEMO MSB
         LD     XIX,100         ;MAKE SUM 100
         LD     A,0             ;CLR
         CAL    KnSUB6          ;BC - DE & INC A
         AND    A,0FH
         OR     E,A             ;D3,D2 in E
         ;
         LD     XIX,10          ;MAKE SUM 10
         LD     A,0             ;CLR
         CAL    KnSUB6          ;BC - DE & INC A
         SLA    4,A             ;4 SIFT UP
         OR     A,C             ;
         LD     C,A
         LD     B,E
         LD     QC,D
         RET
         ;
KnSUB6:  CP     XBC,XIX         ;CHK BC,DE
         RET    C               ;BC < DE
         SUB    XBC,XIX
         INC    1,A             ; * n INC
         J      KnSUB6
         RET
         ;
PUT09M:  LD     XBC,999999
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ; 4 BINARY -> ASCII ݶ
         ; IN BINARY=BC  (MAX = 9999)
         ; OUT ASCII=1070H TOP
B_ASC4:  CAL    BINBCD4         ;IN=BC OUT=BC
         LD     (CB2),BC        ;X4-3=CB3 X2-1=CB2
         LD     A,B
         CAL    HACHG           ;HEX=A ASCII=BC
         LD     XHL,1070H       ;SAVE X4 ASCII
         LD     (XHL),B
         INC    1,XHL           ;SAVE X3 ASCII
         LD     (XHL),C
         LD     A,(CB2)
         CAL    HACHG           ;HEX=A ASCII=BC
         LD     XHL,1072H       ;SAVE X2 ASCII
         LD     (XHL),B
         INC    1,XHL           ;SAVE X1 ASCII
         LD     (XHL),C
         INC    1,XHL           ;SAVE NUL
         LD     (XHL),00H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;
         ; BINARY BCD CHANGE
         ; IN:BINARY=BC(MAX 9999)  OUT:BCD=BC
BINBCD4: CP     BC,9999         ;MAX CHK
         CAL    NC,PUT9K
         LD     DE,1000         ;MAKE SUM 1000
         LD     A,0             ;CLR
         CAL    KnSUB4          ;BC - DE & INC A
         SLA    4,A             ;4 SIFT UP
         LD     W,A             ;MEMO MSB
         LD     DE,100          ;MAKE SUM 100
         LD     A,0             ;CLR
         CAL    KnSUB4          ;BC - DE & INC A
         AND    A,0FH
         OR     W,A             ;D3,D2 in W
         ;
         LD     DE,10           ;MAKE SUM 10
         LD     A,0             ;CLR
         CAL    KnSUB4          ;BC - DE & INC A
         SLA    4,A             ;4 SIFT UP
         OR     A,C             ;
         LD     BC,WA
         RET
         ;
KnSUB4:  CP     BC,DE           ;CHK BC,DE
         RET    C               ;BC < DE
         SUB    BC,DE
         INC    1,A             ; * n INC
         J      KnSUB4
         RET
PUT9K:   LD      BC,9999
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;
         ; HEX ASCII CHANGE
         ; IN HEX=A, OUT ASCII=BC
HACHG:   PUSH    A              ;BIN DATA BREEF SAVE
         RLC    4,A
         AND    A,0FH
         CAL    AB_ADD
         LD     B,A             ;UPPER NIBLE SAVE
         POP    A
         AND    A,0FH           ;CUT BIN UPPER
         CAL    AB_ADD
         LD     C,A             ;LOWER NIBLE SAVE
         RET
         ;
AB_ADD:  CP     A,0AH           ;00-09 ?
         J      C,PLS30
         ADD    A,07H
PLS30:   ADD    A,30H
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;     LCD ۰ GOODS           ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;  خ IN:OUT DATA=Areg
C_OUT:   LD     W,A
         AND    (P6),2FH        ;CS=0, A0=0
         SRL    4,W             ;ް MSB خ ޭ
         SET    5,(P6)          ;E=1
         LD     (P7),W          ;ް MSB خ
         RES    5,(P6)          ;E=0
         NOP
         SET    5,(P6)          ;E=1
         LD     (P7),A          ;ް LSB خ
         RES    5,(P6)          ;E=0
         SET    4,(P6)          ;CS=1
         RET
         ;
         ; ް خ IN:A=OUT DATA
D_OUT:   LD     W,A
         SET    6,(P6)          ;A0=1
         RES    4,(P6)          ;CS=0
         SRL    4,W             ;ް MSB خ ޭ
         SET    5,(P6)          ;E=1
         LD     (P7),W          ;ް MSB خ
         RES    5,(P6)          ;E=0
         NOP
         SET    5,(P6)          ;E=1
         LD     (P7),A          ;ް LSB خ
         RES    5,(P6)          ;E=0
         SET    4,(P6)          ;CS=1
         INC    1,(105BH)       ;INC  DD ADDRESS 
         RET
         ;
         ;  ΰ,  DD ADDRESS=30H
C_HOME:  LD     A,10H           ; ΰ 
         CAL    C_OUT           ; خ
         LD     (105BH),30H     ; DD ADDRESS   
         RET
         ;
         ;
         ; ˮ CLR
D_CLR:   LD     A,30H           ;DDRAM TOP
         LD     XHL,TB_BLK
         CAL    PRINT
         LD     A,30H           ;DDRAM TOP
         ;  DD ADDRESS SET  IN:A=DDRAM ADDRESS   30H=HOME
DDSET:   LD     (105BH),A       ; DD ADDRESS  
         SET    7,A             ; DD ADDRESS 
         CAL    C_OUT           ; خ
         RET
         ;
         ; IN:XHL=TABLE TOP  IN:A=DDRAM ADDRESS
PRINT:   CAL    DDSET           ; DD ADDRESS SET
LP_PRN:  LD     A,(XHL)         ;TABLE DATA CHK
         CP     A,00H           ;NUL
         RET    Z
         INC    1,XHL           ;INC TABLE POINTER
         CAL    D_OUT           ;ް خ
         J      LP_PRN
         RET
         ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ;    INTERRUPT VECT TABLE        ;
         ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         ORG     VECT_TOP
         ;
         DL     START           ;START VECT       VECT=00H
         DL     SWI_1           ;SOFTWARE INT 1   VECT=04H
         DL     SWI_2           ;             2   VECT=08H
         DL     SWI_3           ;             3   VECT=0CH
         DL     SWI_4           ;             4   VECT=10H
         DL     SWI_5           ;             5   VECT=14H
         DL     SWI_6           ;             6   VECT=18H
         DL     SWI_7           ;             7   VECT=1CH
         DL     NMIINT          ;NOON MASK INT    VECT=20H
         DL     WDT_OVR         ;WDT TIME OVER    VECT=24H
         ;
         DL     INT0_Z          ;INT 0 TERMINAL   VECT=28H
         DL     INT1_Z          ;INT 1 TERMINAL   VECT=2CH
         DL     INT2_Z          ;INT 2 TERMINAL   VECT=30H
         DL     INT3_Z          ;INT 3 TERMINAL   VECT=34H
         DL     INT4_Z          ;INT 4 TERMINAL   VECT=38H
         DL     INT5_Z          ;INT 5 TERMINAL   VECT=3CH
         DL     INT6_Z          ;INT 6 TERMINAL   VECT=40H
         DL     INT7_Z          ;INT 7 TERMINAL   VECT=44H
         DL     INT8_Z          ;INT 8 TERMINAL   VECT=48H
         DL     INTTA0          ;8bit TIM_0 INT   VECT=4CH
         DL     INTTA1          ;8bit TIM_1 INT   VECT=50H
         DL     INTTA2          ;8bit TIM_2 INT   VECT=54H
         DL     INTTA3          ;8bit TIM_3 INT   VECT=58H
         DL     INTTA4          ;8bit TIM_4 INT   VECT=5CH
         DL     INTTA5          ;8bit TIM_5 INT   VECT=60H
         DL     INTTA6          ;8bit TIM_6 INT   VECT=64H
         DL     INTTA7          ;8bit TIM_7 INT   VECT=68H
         DL     INTTB00         ;16bit TIM0 TRG0  VECT=6CH
         DL     INTTB01         ;16bit TIM0 TRG1  VECT=70H
         DL     INTTB10         ;16bit TIM1 TRG0  VECT=74H
         DL     INTTB11         ;16bit TIM1 TRG1  VECT=78H
         DL     INTTBOF0        ;16bit TIM0       VECT=7CH
         DL     INTTBOF1        ;16bit TIM1       VECT=80H
         ;
         DL     INTRX0          ;SIO_0 RX         VECT=84H
         DL     INTTX0          ;SIO_0 TX         VECT=88H
         DL     INTRX1          ;SIO_1 RX         VECT=8CH
         DL     INTTX1          ;SIO_1 TX         VECT=90H
         DL     INTSBI          ;ر޽̪  VECT=94H
         DL     INTRTC          ;Ĺֳغ     VECT=98H
         DL     INT_AD          ;A/D CONVERTED    VECT=9CH
         DL     INTTC0          ;ϲDMAخ    VECT=A0H
         DL     INTTC1          ;ϲDMAخ    VECT=A4H
         DL     INTTC2          ;ϲDMAخ    VECT=A8H
         DL     INTTC3          ;ϲDMAخ    VECT=ACH
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
END
