/*******************************************************
***********   ׯROM  routine   CPU = TMP91FY22F  *********/

#include        "io900l2.h"
#include        <stdlib.h>
#pragma section  code  cpy_pro
extern unsigned char    f_odr;           // F_ROM ٰ ˷ No
extern unsigned char    f_cnt;           // F_ROM ޮ ӰNo
extern unsigned int     *F_FROM;         // F_ROM   
extern unsigned int     *F_TO;           // F_ROM  
extern unsigned int     F_CT;            // F_ROM  word ct
volatile unsigned char  *FCAA;           //  WR ڽ 1
volatile unsigned char  *FC55;           //  WR ڽ 2
       unsigned long    mon_tim;         // ٰ ݼ 
       unsigned int     *TOmem;          // F_ROM   
       unsigned int     D_mem;           // F_ROM  ް 
       unsigned char    f_stat;          // F_ROM ð
       unsigned char    WRstat;          // F_ROM   ˮ
       unsigned char    offnor;          // F_ROM ޮ ð

/************************************************************/
 //   - set
void  M30_WR()
{     f_odr = 0x31;                    // · odr No31= -  
      *FCAA = 0xaa;                    // 1st bus WR CYCLE
      *FC55 = 0x55;                    // 2nd bus WR CYCLE
      *FCAA = 0xa0;                    // 3rd bus WR CYCLE
      *F_TO = *F_FROM;                 // F_ROM ް 
      D_mem = *F_FROM;                 // F_ROM  ް ӽ
      TOmem = F_TO;                    // F_ROM   ӽ
     F_FROM += 1;                      // from pointer inc
      F_TO  += 1;                      // to pointer inc
     WRstat &= 0xf0;                   //   ˮ buf clr
     mon_tim = 0xffff;                 // ٰ ݼ  set
}

 // F_ROM ޮ bit ON, ذ޻  ޽
void  R_RESET()
{     f_odr = 0x00;                    // odr No= ذ޻ 
      offnor|= 0x01;                   // F_ROM ޮ bit ON
      *FCAA = 0xaa;                    // 1st bus WR CYCLE
      *FC55 = 0x55;                    // 2nd bus WR CYCLE
      *FCAA = 0xf0;                    // 3rd bus WR CYCLE
}

 // ׯ ROM  - CHK, ߰ݸbit  - chk
void  F_STAT()
{     unsigned char d;
      f_stat =*(unsigned char*)TOmem;        //  byte
      d = (unsigned char)D_mem;              //  ް byte
      if((f_stat & 0x80) == (~d & 0x80))     // ߰ݸ bit chk
        { if(f_stat & 0x20)                  // bit 5,f_stat, TIME OVER CHK
            WRstat |= 0x04;                  // set 2,WRstat, TIME OVER FLG ON
        }
      else if(*TOmem == D_mem)               //  - CHK
             WRstat |= 0x01;                 // set 0,WRstat, ޮ خ FLG ON
            else
             WRstat |= 0x02;                 // set 1,WRstat, - ̲ FLG ON
}
       
  // F_ROM  
void  M31_WR()
{     if((mon_tim --) != 0)                  // ٰ ݼ  dec & chk
        { F_STAT();                          //  - CHK
          if((WRstat & 0x07) != 0x00)        //   ˮ buf chk
             {if(WRstat & 0x04)              // time over then reset
                R_RESET();
              else if((--F_CT) != 0)         //  ܰ  dec & chk
                     M30_WR();               // 
                   else
                     f_odr = 0x00;           //  0޵clr & ret
             }
        }
       else
         R_RESET();                          // F_ROM ޮ bit ON, ذ޻  ޽
}

 //  (ۯ) n ڰ
void  B_ERAS(unsigned long b_top)
{     unsigned char *top;
      *FCAA = 0xaa;                    // 1st bus WR CYCLE
      *FC55 = 0x55;                    // 2nd bus WR CYCLE
      *FCAA = 0x80;                    // 3rd bus WR CYCLE
      *FCAA = 0xaa;                    // 4th bus WR CYCLE
      *FC55 = 0x55;                    // 5th bus WR CYCLE
        top = (unsigned char*)b_top;
       *top = 0x30;                    // ڰ  ʯ
      b_top |= 0xffe;                  //    ¸
      TOmem = (unsigned int*)b_top;    // F_ROM   ӽ
      D_mem = 0xffff;                  // F_ROM  ް ӽ
    mon_tim = 0x64ffff;                // ٰ ݼ  set
      f_odr = 0x20;                    // odr No20= ڰ 
     WRstat &= 0xf0;                   //   ˮ buf clr
}

 //  F =  ڰ
void  C_ERAS()
{     *FCAA = 0xaa;                    // 1st bus WR CYCLE
      *FC55 = 0x55;                    // 2nd bus WR CYCLE
      *FCAA = 0x80;                    // 3rd bus WR CYCLE
      *FCAA = 0xaa;                    // 4th bus WR CYCLE
      *FC55 = 0x55;                    // 5th bus WR CYCLE
      *FCAA = 0x10;                    // 6th bus WR CYCLE
      TOmem = (unsigned int*)0xfc0000; // F_ROM   ӽ
      D_mem = 0xffff;                  // F_ROM  ް ӽ
    mon_tim = 0x64ffff;
      f_odr = 0x20;                    // odr No20= ڰ 
     WRstat &= 0xf0;                   //   ˮ buf clr
}

 //  F_ROM order chk
void  F_ROM1()
{     switch (f_odr){
      case 0x30: M30_WR(); break;          //  -
      case 0x31: M31_WR(); break;          //  - 
      case 0x10: B_ERAS(0xfc0000); break;  //  0 ڰ
      case 0x11: B_ERAS(0xfd0000); break;  //  1 ڰ
      case 0x12: B_ERAS(0xfe0000); break;  //  2 ڰ
      case 0x13: B_ERAS(0xff0000); break;  //  3 ڰ
      case 0x14: B_ERAS(0xff8000); break;  //  4 ڰ
      case 0x15: B_ERAS(0xffa000); break;  //  5 ڰ
      case 0x16: B_ERAS(0xffc000); break;  //  6 ڰ
      case 0x1f: C_ERAS(); break;  }       // F =  ڰ
}

/************************************************************/
 //  erase status chk
void  ERSCHK()
{      if(f_odr == 0x20)
         { if((mon_tim --) != 0)               // ٰ ݼ  dec & chk
             { F_STAT();                       // ڰ - CHK
               if((WRstat & 0x07) != 0x00)     // ڰ  ˮ buf chk
                  {if(WRstat & 0x04)           // time over then reset
                     R_RESET();
                   else
                     f_odr = 0x00;             //  0޵clr & ret
                  }
             }
           else
             R_RESET();                        // F_ROM ޮ bit ON, ذ޻  ޽
         }
}

/************************************************************/
 // ׯROM  routine, CALL from zfx31.c
void    F_ROM(void)
{  __DI();
     while(f_odr != 0x00) {
         WDCR    = 0x4E;              // WD timer CT clr
         ERSCHK();                    // erase status chk
         F_ROM1();                    // F_ROM order chk
     }
   __EI();
}
