/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: assert.h,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2003/05/20 09:56:08 $	*/

#ifndef	__ASSERT_H
#define	__ASSERT_H

#ifndef	__CDECL
#if	__STDC__
#define	__CDECL
#else
#define	__CDECL	__cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#undef	assert
#ifdef	NDEBUG
#define	assert(ignore)	((void)0)
#else
void __CDECL	_assert(const char *expression, const char *filename, unsigned int line);
#define	assert(expression)	((expression) ? (void)0 : _assert(#expression, __FILE__, __LINE__))
#endif	/* NDEBUG */
#endif	/* __ASSERT_H */
