/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: limits.h,v $	*/
/*	$Revision: 1.7 $	*/
/*	$Date: 2003/05/20 09:59:03 $	*/

#ifndef	__LIMITS_H
#define	__LIMITS_H

#define	CHAR_BIT	8
#define	SCHAR_MAX	127
#define	SCHAR_MIN	(-127)
#define	SHRT_MAX	32767
#define	SHRT_MIN	(-32767)
#define	LONG_MAX	(2147483647)
#define	LONG_MIN	(-2147483647)
#define	UCHAR_MAX	255U
#define	UCHAR_MIN	0
#define	USHRT_MAX	65535U
#define	ULONG_MAX	4294967295U
#define	USHRT_MIN	0
#define	ULONG_MIN	0
#define	MB_LEN_MAX	4

#ifdef __CHAR_UNSIGNED__
#define	CHAR_MAX	UCHAR_MAX
#define	CHAR_MIN	UCHAR_MIN
#else
#define	CHAR_MAX	SCHAR_MAX
#define	CHAR_MIN	SCHAR_MIN
#endif

#if defined (__900__) || defined (__870X__) || defined (__870__) || defined(__90__) || defined(__870C__)
#define	INT_MAX		SHRT_MAX
#define	INT_MIN		SHRT_MIN
#define	UINT_MAX	USHRT_MAX
#define	UINT_MIN	USHRT_MIN
#endif

#endif	/* __LIMITS_H */
