/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: math.h,v $	*/
/*	$Revision: 1.4 $	*/
/*	$Date: 2003/05/20 09:59:44 $	*/

#ifndef	__MATH_H
#define	__MATH_H

#ifndef	__CDECL
#if	__STDC__
#define	__CDECL
#else
#define	__CDECL	__cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#ifdef UDE_CC	/* using UDE C compiler floating fixed number convert */

/*	#define	HUGE_VAL	1.7976931348623157e+308	*/
#define	HUGE_VAL	1.79769313486231500e+308		/* for using Watcom C	*/

#else		/* floating fixed number bit pattern definition */

#ifndef __FLOAT_H

typedef union {
	unsigned char dat[4] ;
	float	val ;
} FLTBIT ;

typedef union {
	unsigned char dat[8] ;
	double	val ;
} DBLBIT ;

typedef union {
	unsigned char dat[10] ;
	long double	val ;
} LDBLBIT ;

#endif

extern	DBLBIT g_mathtbl[] ;

#define	HUGE_VAL	g_mathtbl[0].val

#endif

#define LN_DBLMAX	709.778
#define LN_DBLMIN	-708.396

/* ANSI */
double __CDECL	acos(double x);
double __CDECL	asin(double x);
double __CDECL	atan(double x);
double __CDECL	atan2(double y, double x);
double __CDECL	ceil(double x);
double __CDECL	cos(double x);
double __CDECL	cosh(double x);
double __CDECL	exp(double x);
double __CDECL	fabs(double x);
double __CDECL	floor(double x);
double __CDECL	fmod(double x, double y);
double __CDECL	frexp(double value, int *exp);
double __CDECL	ldexp(double x, int exp);
double __CDECL	log(double x);
double __CDECL	log10(double x);
double __CDECL	modf(double value, double *iptr);
double __CDECL	pow(double x, double y);
double __CDECL	sin(double x);
double __CDECL	sinh(double x);
double __CDECL	sqrt(double x);
double __CDECL	tan(double x);
double __CDECL	tanh(double x);

#endif	/* __MATH_H	*/
