/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: string.h,v $	*/
/*	$Revision: 1.3 $	*/
/*	$Date: 2003/05/22 02:58:21 $	*/

#ifndef	__STRING_H
#define	__STRING_H

#ifndef	__CDECL
#if	__STDC__
#define __CDECL
#else
#define __CDECL __cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#ifndef	__SIZE_T
#define	__SIZE_T
typedef	unsigned int	size_t;
#endif	/* __SIZE_T */

#ifndef	NULL
#define	NULL	((void *)0)
#endif

/* ANSI */
void * __CDECL	__far_pic memchr(const void *s, int c, size_t n);
int __CDECL	__far_pic memcmp(const void *s1, const void *s2, size_t n);
void * __CDECL	__far_pic memcpy(void *s1, const void *s2, size_t n);
void * __CDECL	__far_pic memmove(void *s1, const void *s2, size_t n);
void * __CDECL	__far_pic memset(void *s, int c, size_t n);

char * __CDECL	__far_pic strcat(char *s1, const char *s2);
char * __CDECL	__far_pic strchr(const char *s, int c);
int __CDECL	__far_pic strcmp(const char *s1, const char *s2);
char * __CDECL	__far_pic strcpy(char *s1, const char *s2);
size_t __CDECL	__far_pic strcspn(const char *s1, const char *s2);
size_t __CDECL	__far_pic strlen(const char *s);
char * __CDECL	__far_pic strncat(char *s1, char *s2, size_t n);
int __CDECL	__far_pic strncmp(const char *s1, const char *s2, size_t n);
char * __CDECL	__far_pic strncpy(char *s1, const char *s2, size_t n);
char * __CDECL	__far_pic strpbrk(const char *s1, const char *s2);
char * __CDECL	__far_pic strrchr(const char *s, int c);
size_t __CDECL	__far_pic strspn(const char *s1, const char *s2);
char * __CDECL	__far_pic strstr(const char *s1,const char *s2);
char * __CDECL	__far_pic strtok(char *s1, const char *s2);

/* Not Support */	/*	int __CDECL	strcoll(const char *s1, const char *s2);	*/
/* Not Support */	/*	char __CDECL	*strerror(int errnum);				*/
/* Not Support */	/*	size_t __CDECL	strxfrm(char *s1, const char *s2, size_t n);	*/

/* Standard */
void * __CDECL	__far_pic memccpy(void *s1, const void *s2, int c, size_t n);
int __CDECL	__far_pic memicmp(void *s1, void *s2, size_t n);
void * __CDECL	__far_pic memswap(void *s1, void *s2, size_t n);

int __CDECL	__far_pic stricmp(const char *s1, const char *s2);
char * __CDECL	__far_pic strlwr(char *s);
int __CDECL	__far_pic strnicmp(const char *s1, const char *s2, size_t n);
char * __CDECL	__far_pic strnset(char *s, int c, size_t n);
char * __CDECL	__far_pic strrev(char *s);
char * __CDECL	__far_pic strset(char *s, int c);
char * __CDECL	__far_pic strupr(char *s);

/* Large amount data */
#if defined (__900__)
void * __CDECL	__far_pic __fmemccpy(void *s1,const void *s2, int c, unsigned long n);
void * __CDECL	__far_pic __fmemchr(const void *s1,int c, unsigned long n);
int __CDECL	__far_pic __fmemcmp(const void *s1,const void *s2,unsigned long n);
void * __CDECL	__far_pic __fmemcpy(void *s1, void *s2, unsigned long n);
void * __CDECL	__far_pic __fmemset(void *s, int c, unsigned long n);
void * __CDECL	__far_pic __fmemmove(void *s1, const void *s2, unsigned long n);
void * __CDECL	__far_pic __fmemswap(void *s1, void *s2, unsigned long n);
#endif

#endif	/* __STRING_H */
