/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _fscanf.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:03:27 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdio.h>
#include <stdarg.h>

int __CDECL	_doscan(const char *fmt, va_list args, int (*fnc)(void), void (*ungetfnc)(int c));

static int __CDECL	_getstmchar(void);
static void __CDECL	_ungetstmchar(int c);

static FILE	*scn_fp;

int __CDECL	fscanf(FILE *stream, const char *format, ...)
{
	va_list	args;

	scn_fp = stream;
	
	va_start(args, format) ;
	return (_doscan(format, args,  _getstmchar, _ungetstmchar)) ;
}

static int __CDECL	_getstmchar(void)
{
	return(fgetc(scn_fp)) ;
}

static void __CDECL	_ungetstmchar(int c)
{
	ungetc(c, scn_fp) ;
}
