/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _fwrite.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:03:27 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdio.h>

size_t __CDECL fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	unsigned int	len;
	unsigned int	ret;
	const char *p = ptr;

	len = ret = size * nmemb;
	if (len == 0)	return 0;

	while(len--)	(*stream->out)(*p++);
	return ret;
}
