/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _atoi.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:07:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <ctype.h>
#include <stdlib.h>

int __CDECL atoi(const char *nptr)
{
	int num = 0;
	int c;
	int sign = 0;
	
	/* white space */
	while (isspace(*nptr))	++nptr;
	if(*nptr == '-')
		sign = 1,++nptr;
	else if (*nptr == '+')
		++nptr;
	for(;;) {
		c = *nptr++;
		if (isdigit(c))
			num = num*10+(c-'0');
		else
			break;
	}
	return (sign ? -num : num);
}
