/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _ultoa.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:07:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdlib.h>

char * __CDECL ultoa(unsigned long val, char *s, int radix)
{
	int u;
	char buf[sizeof(long) * 8 + 1];
	char *p;
	char *q = s;

	if ((radix < 2) || (radix > 36))
	{
		s[0] = 0;
		return (s);
	}

	buf[sizeof(buf) - 1] = 0;
	p = &buf[sizeof(buf) - 2];
	while (1) {
		*p = (val % radix) + '0';
		if (*p > '9')	*p += 'a'-'0'-10;
		if ((val /= radix) == 0)	break;
		p--;
	}
	memcpy(q, p, &buf[sizeof(buf)] - p);
	return (s);
}
