/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _fmccpy.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:14:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <string.h>

#if defined(__900__) || (defined(__870X__) && defined(__LARGE__))
void *__fmemccpy(void *s1,const void *s2, int c, unsigned long n) {
	unsigned char *pos;

	pos = (unsigned char *)__fmemchr(s2,c,n);
	if(pos==NULL) {
		__fmemcpy(s1,s2,n);
		}
	else {
		unsigned long nn;
		nn = pos - (unsigned char *)s2 + 1;
		__fmemcpy(s1,s2,nn);
		}
	return s1;
}
#else
void * __CDECL __fmemccpy(void *s1,const void *s2, int c, unsigned long n)
{
	unsigned char c0;
	unsigned char *p1 = s1;
const	unsigned char *p2 = s2;

	while (n--) {
		c0 = *p1++ = *p2++;
		if ((unsigned char)c == c0)
			return ((void *)p1);
	}
	return ((void *)NULL);
}
#endif
