/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _fmemcpy.c,v $	*/
/*	$Revision: 1.4 $	*/
/*	$Date: 2002/08/13 11:55:25 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <string.h>

#if	defined(__900__) && !defined(PIC)
void *__fmemcpy(void *s1, void *s2, unsigned long n) {
	__ASM("		;; @(#)fmemcpy.s	1.2 95/07/13");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; void *__fmemcpy(void *s1, void *s2, unsigned long n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s1	:		XSP+4");
	__ASM("		;; s2	:		XSP+8");
	__ASM("		;; n	:		XSP+12");
	__ASM("		;; ");
	__ASM("		ld		XBC,(XSP+12)");
	__ASM("		ld		XHL,(XSP+4)");
	__ASM("		and		XBC,0x00ffffff	; 16M Byte");
	__ASM("		ret		z");
	__ASM("		;;");
	__ASM("		ld		XIX,XHL			; s1");
	__ASM("		ld		XIY,(XSP+8)		; s2");
	__ASM("		cp		XIX,XIY");
	__ASM("		ret		eq");
	__ASM("		;;");
	__ASM("		bit		0,IX			; address check");
	__ASM("		j		z,__Skip");
	__ASM("		ld		A,(XIY+)");
	__ASM("		ld		(XIX+),A");
	__ASM("		sub		XBC,1");
	__ASM("		ret		z			; XBC == 0");
	__ASM("__Skip:");
	__ASM("		srl		1,XBC			; /= 2 & set B0 to C-flag");
	__ASM("		jr		z,__ByteCopy");
	__ASM("		ld		DE,QBC");
	__ASM("		cp		BC,0");
	__ASM("		jp		z,__WordCopy");
	__ASM("		inc		1,DE");
	__ASM("__WordCopy:		");
	__ASM("		ldirw	(XIX+),(XIY+)");
	__ASM("		djnz	DE,__WordCopy");
	__ASM("__ByteCopy:");
	__ASM("		ret		nc");
	__ASM("		ldib	(XIX+),(XIY+)");
	__ASM("		;; ret");
	return (void *)__XHL;
}
#elif (defined(__870X__) && defined(__LARGE__))
void *__fmemcpy(void *s1, void *s2, unsigned long n) {
	__ASM("		;; @(#)fmemcpy.s	1.2 97/12/19");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; void *__fmemcpy(void *s1, void *s2, unsigned long n)");
	__ASM("		;; RET	:	s1");
	__ASM("		;; s1	:	SP+0x4");
	__ASM("		;; s2	:	SP+0x7");
	__ASM("		;; n	:	SP+0xa");
	__ASM("		;; ");
	__ASM("		ld		IX,	(SP+0x4);	s1		");
	__ASM("		ld		IY,	(SP+0x7);	s2		");
	__ASM("		ld		BC,	(SP+0xa);	n(low)	");
	__ASM("		ld		DE,	(SP+0xc);	n(high)	");
	__ASM("		;					;			");
	__ASM("		test	C.0			;	odd?	");
	__ASM("		j		t,	__Div2	;			");
	__ASM("		;					;			");
	__ASM("__ByteCpy:");
	__ASM("		ld		A,	(IY)	;			");
	__ASM("		ld		(IX),A		;			");
	__ASM("		inc		IY			;			");
	__ASM("		inc		IX			;			");
	__ASM("__Div2:");
	__ASM("		shrc	D			;			");
	__ASM("		rorc	E			;			");
	__ASM("		rorc	B			;			");
	__ASM("		rorc	C			;			");
	__ASM("		cmp		BC,	0x0		;			");
	__ASM("		j		t,	__EndBC	;			");
	__ASM("		;					;			");
	__ASM("__WordCpy:");
	__ASM("		ld		WA,	(IY)	;			");
	__ASM("		ld		(IX),WA		;			");
	__ASM("		inc		IX			;			");
	__ASM("		inc		IX			;			");
	__ASM("		inc		IY			;			");
	__ASM("		inc		IY			;			");
	__ASM("		dec		BC			;			");
	__ASM("		j		nz,	__WordCpy;			");
	__ASM("		;					;			");
	__ASM("__EndBC:");
	__ASM("		dec		DE			;			");
	__ASM("		j		f,	__WordCpy;			");
	__ASM("		;					;			");
	__ASM("__End:");
	__ASM("		ld		IY,	(SP+0x4);			");
	__ASM("		;					;ret		");
	return (void *)__IY;
}
#else
void * __CDECL __fmemcpy(void *s1, const void *s2, unsigned long n)
{
	void *s = s1;
	unsigned char	*p1 = s1;
const	unsigned char	*p2 = s2;


	while (n--) {
		*p1++ = *p2++;
	}
	return (s);
}
#endif
