/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _fmemset.c,v $	*/
/*	$Revision: 1.4 $	*/
/*	$Date: 2002/03/27 05:47:28 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <string.h>

#if defined(__900__) && !defined(PIC)
void *__fmemset(void *s, int c, unsigned long n) {
	__ASM("		;; @(#)fmemset.s	1.1 95/07/13");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; void *__fmemset(void *s, int c, unsigned long n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s	:		XSP+4");
	__ASM("		;; c	:		XSP+8");
	__ASM("		;; n	:		XSP+10");
	__ASM("		;; ");
	__ASM("		ld		XBC,(XSP+10)		; n");
	__ASM("		ld		XHL,(XSP+4)		; s");
	__ASM("		and		XBC,0x00ffffff	; 16M Byte");
	__ASM("		ret		z");
	__ASM("		ld		XIX,XHL");
	__ASM("		ld		WA,(XSP+8)		; c");
	__ASM("		;;");
	__ASM("		ld		DE,IX");
	__ASM("		neg		DE");
	__ASM("		and		DE,0x3			; 4m+0?");
	__ASM("		jr		z,__LongSet");
	__ASM("		;;");
	__ASM("__ByteSet1:");
	__ASM("		ld		(XIX+),A");
	__ASM("		sub		XBC,0x1");
	__ASM("		ret		z");
	__ASM("		djnz	DE,__ByteSet1");
	__ASM("		;;");
	__ASM("__LongSet:		");
	__ASM("		ld		DE,BC");
	__ASM("		srl		2,XBC");
	__ASM("		jr		z,__ByteSet2");
	__ASM("		ld		W,A");
	__ASM("		ld		QWA,WA");
	__ASM("		ld		IY,QBC");
	__ASM("		cp		BC,0");/* 2002.3.27 */
	__ASM("		jp		z,__LongLoop");/* 2002.3.27 */
	
	__ASM("		inc		1,IY");
	__ASM("__LongLoop:");
	__ASM("		ld		(XIX+),XWA");
	__ASM("		djnz	BC,__LongLoop");
	__ASM("		djnz	IY,__LongLoop");
	__ASM("__ByteSet2:		");
	__ASM("		and		DE,0x3");
	__ASM("		ret		z");
	__ASM("__ByteLoop2:");
	__ASM("		ld		(XIX+),A");
	__ASM("		djnz	DE,__ByteLoop2");
	__ASM("		;; ret");
	return (void *)__XHL;
}
#elif (defined(__870X__) && defined(__LARGE__))
void *__fmemset(void *s, int c, unsigned long n) {
	__ASM("		;; @(#)fmemset.s	1.2 97/12/19");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; void *__fmemset(void *s, int c, unsigned long n)");
	__ASM("		;; RET	:	s1");
	__ASM("		;; s	:	SP+0x4");
	__ASM("		;; c	:	SP+0x7");
	__ASM("		;; n	:	SP+0x9");
	__ASM("		;; ");
	__ASM("		ld		IX,	(SP+0x4);	s1		");
	__ASM("		ld		IY,	IX		;	RET		");
	__ASM("		ld		A,	(SP+0x7);	c		");
	__ASM("		ld		BC,	(SP+0x9);	n(low)	");
	__ASM("		ld		DE,	(SP+0xb);	n(high)	");
	__ASM("		;					;			");
	__ASM("		test	C.0			;	odd?	");
	__ASM("		j		t,	__Div2	;			");
	__ASM("		;					;			");
	__ASM("__ByteSet:");
	__ASM("		ld		(IX),A		;			");
	__ASM("		inc		IX			;			");
	__ASM("		;					;			");
	__ASM("__Div2:");
	__ASM("		shrc	D			;			");
	__ASM("		rorc	E			;			");
	__ASM("		rorc	B			;			");
	__ASM("		rorc	C			;			");
	__ASM("		ld		W,	A		;			");
	__ASM("		cmp		BC,	0x0		;			");	
	__ASM("		j		t,	__EndBC	;			");
	__ASM("		;					;			");
	__ASM("__WordSet:");
	__ASM("		ld		(IX),WA		;			");
	__ASM("		inc		IX			;			");
	__ASM("		inc		IX			;			");
	__ASM("		dec		BC			;			");
	__ASM("		j		nz,	__WordSet;			");
	__ASM("		;					;			");
	__ASM("__EndBC:");
	__ASM("		dec		DE			;			");
	__ASM("		j		f,	__WordSet;			");
	__ASM("		;					;			");
	__ASM("__End:");
	__ASM("		;					;ret		");
	return (void *)__IY;
}
#else
void * __CDECL __fmemset(void *s, int c, unsigned long n)
{
	void *s0 = s;
	unsigned char	*p = (unsigned char *)s;

	while (n--) {
		*p++ = (unsigned char)c;
	}
	return (s0);
}
#endif
