/*******************************************************
***********   startup routine   CPU = TMP91FY22F   **********/

#include        "io900l2.h"
#include        <stdlib.h>
#define   BaseXSP         0x005000       // Stack area bottom address 03/08/08

//  ˰ خ ν  ݽ malloc, calloc, realloc ¶ķ ޭ
// #define   HeapTop      (void*)0x4000  // Heap area top address
// #define   HeapSize     0x800          // Heap area size
// void*   SBRK_break = HeapTop;         // Set Heap area top address
// int     SBRK_size = HeapSize;         // Set Heap area size
// void*   _allocb=((void *)0);          // memory management pointer
int     errno;                           // error code for mathematics
// void    exit(int status){             // library function: exit()
//        __asm(" halt"); }
// void    abort(void){                  // library function: abort() 
//       __asm("; j      __startup");}


/*========      org start       ============*/
/*========   initial routine    ============*/

#pragma   section   code    f_code
extern long    _RAM_dat;               // ram ްخ
unsigned char   sft_bit =0x01;         // 1.25msec 1 ı߽ bit
unsigned char   n125ct =80;            // 1.25msec * 80=100msec 
unsigned char   n0r1ct =10;            // 0.1sec * 10=1sec 
unsigned char   f125 =0x00;            // 1.25msec flag
unsigned char   f10ms =0x00;           // 1.25msec * 8sift=10msec flag
unsigned char   f0r1s =0x00;           // 0.1sec flag
unsigned char   f1sec =0x00;           // 1sec flag
unsigned char   aux125;                // 1.25msec * n timer
unsigned char   ad_ct =64;             // ADݶ  
unsigned char   RXD1;                  // SIO ch1 ޭް
extern unsigned char ST_FLG;

void    _startup(void){
  __DI();                              // غзݼ
        WDCR    =0x4E;                 // WD timer CT clr
        WDMOD   =0xE2;                 // WD timer ON, 213ms clr, reset mode
  __XSP     =BaseXSP;                  // BaseXSP = 0x005000

        DFMCR1  =0x0B;                 // DFM = analog set
        DFMCR0  =0x40;                 // DFM, LUP=run, LUO2^12
  __asm("LP_LUP:");
  __A       =DFMCR0;                   // ڼ޽ ޼ ݽ
  __asm("BIT     5,A");                // LUP timer chk
  __asm("J       NZ,LP_LUP");          // wait loop
        DFMCR0  =0x80;                 // fc=fDFM fc=6.144Mhz *4=24.576Mhz
        SYSCR1  =0x00;                 // clk = high speed
        aux125  =0x00;                 // dumy out
        EMCCR0  =0x2a;                 // ALE = on

        P1CR    =0x00;                 // P1CR=0 & P1FC=1
        P1FC    =0xFF;                 // P1=A/D Bus
        IOP2    =0xFF;                 // P2=11111111
        P2CR    =0xFF;                 // P2CR=1=OUT
        P2FC    =0x0F;                 // P2=PPPPAAAA
        IOP3    =0x78;                 // P3=-1111000
        P3CR    =0x7F;                 // P3=-ooooooo
        P3FC    =0x07;                 // P3=-PPPPccc
        P4FC    =0x02;                 // P4=----PPcP
        P4CR    =0x0E;                 // P4=----oooi

        IOP6    =0x50;                 // P6=-101----
        P6FC    =0x08;                 // P6=-PPPIPPP
        P6CR    =0x77;                 // P6=-oooiooo
        P7FC    =0x20;                 // P7=--TPPPPP
        P7CR    =0x2F;                 // P7=--oioooo
        P8FC    =0x00;                 // P8=PPPPPPPP
        P8CR    =0xFF;                 // P8=oooooooo
        P9FC    =0x08;                 // P9=PPPSSPPP
        P9CR    =0xEF;                 // P9=oooioooo
        PAFC    =0x00;                 // PA=PPPPPPPP
        PACR    =0xFF;                 // PA=oooooooo

        MSAR1   =0x10;                 // CS_1: 1Mbyte SRAM
        MAMR1   =0x3F;                 // 100000H -> 1FFFFFH
        B1CS    =0x83;                 // 16bit bus 0wait

    /*====   area  خ ۸ر   ====*/
  __asm("LD      XDE,startof(f_area)");
  __asm("LD      XBC,sizeof(f_area)");
  __asm("LD      IX,BC");
  __asm("SRL     1,XBC");              // ݿ word = byte /2
  __asm("J     Z,FA2");                // 1word 
  __asm("LD    XHL,XDE");              // from ADDRESS SET
  __asm("LDW   (XDE+),0");             // 1st word CLR
  __asm("SUB   XBC,1");
  __asm("J     Z,FA2");
  __asm("LDIRW");
  __asm("CP    QBC,0");                // 64K word over chk
  __asm("J     Z,FA2");
  __asm("LD    WA,QBC");
  __asm("FA3:");                       // 64k word * n ݿ
   WDCR   =  0x4E;                     // WD timer CT clr
  __asm("LDIRW");
  __asm("DJNZ    WA,FA3");
  __asm("FA2:");
  __asm("BIT   0,IX");                 // 1/2 word chk
  __asm("J     Z,FA1");
  __asm("LD    (XDE),0");
  __asm("FA1:");
   WDCR   =  0x4E;                     // WD timer CT clr

 /*===   RAMخ ۸Ѧ ݿ   ===*/
  __asm("LD    XDE,__RAM_dat");        // RAM۸ خ TOP address
  __asm("LD    XHL,startof(f_data)");  // ݿ ڽ
  __asm("LD    XBC,sizeof(f_data)");
  __asm("OR    XBC,XBC");              //  byte chk
  __asm("J     Z,FD1");
  __asm("LDIR");
  __asm("CP    QBC,0");                // 64K byte over chk
  __asm("J     Z,FD1");
  __asm("LD    WA,QBC");
  __asm("FD2:");
   WDCR   =  0x4E;                    // WD timer CT clr
  __asm("LDIR");
  __asm("DJNZ   WA,FD2");
  __asm("FD1:");

  __asm("LD    XHL,0xFC0000");         // ݿ ڽ
  __asm("LD    XDE,0x4000");           // RAM۸ خ TOP address
  __asm("LD    XBC,0x1000");
  __asm("LDIR");

    /*===   TIMER A 0,1 initial set    ===*/
        TA01RUN =0x00;                 // TA01 STOP & CLR
        TA01MOD =0x09;                 // 8bit TIM,TIM1=xT16,TIM0= xT1
        TA1FFCR =0x00;                 // OUT F/F OFF
  //    TA0REG  =153;                  // 0.3255sec * 153=50sec  @24.576MHz
        TA1REG  =240;                  // 5.2sec * 240=1.25msec  @24.576MHz
        INTETA01=0x50;                 // TA1=INT ENABLE, LEVEL5
        TA01RUN =0x06;                 // PRESCALER, TA 1 RUN

    /*===   رI/O  ch0 ch1 initial set  ===*/
        BR0CR   =0x1A;                 // ch0 9600bps  @24.576MHz
        SC0MOD0 =0x09;                 //     RX=DISABLE, 8bit, B/G USE
        SC0CR   =0x00;                 //     NOON PARI
        INTES0  =0x00;                 //     TX INT=OFF RX INT=OFF

        BR1CR   =0x1A;                 // ch1 9600bps  @24.576MHz
        SC1MOD0 =0x29;                 //     RX=ENABLE, 8bit, B/G USE
        SC1CR   =0x00;                 //     NOON PARI
        INTES1  =0x04;                 //     TX INT=OFF RX INT=LV4

    /*===    A/D ް  initial set   ===*/
        ADMOD1  =0x81;                 // Vref -> ON, ch=0->1 
        ADMOD0  =0x02;                 // ݸӰ ٽӰ
        INTCLR  =0x27;                 // A/D INT FLG CLR
        INTE0AD =0x40;                 // A/D ݶ خ غ ENABLE

    /*===    ޲ݼ غ ò    ===*/
        IIMC    =0x04;                 // INT0_Z= غ
        INTCLR  =0x0A;                 // INT0_Z FLG CLR
        INTE0AD =0x45;                 // INT0_Z & A/D ݶ خ غ ENABLE



        WDCR    = 0x4E;                // WD timer CT clr
        __EI();                        // Enable interrupt
        main();                        // call main function
        __asm(" halt");                // Hook for abnormal end
}

void   ad_start(){                     // ADC Ľ
       if(!(ADMOD0 & 0x40))
       ADMOD0 = ADMOD0 | 0x01;
       }

/*============================================
  =====   Interrupt service routine   ======*/
    //    а غ   
void __regbank(-1)  _Int_dummy(void)
{
}

    //   ޲ ݼ ƭخ غ   
void __regbank(-1)  INT0_Z(void)
{
      BEEP();
}

    // A ch1 ı غ
void  __regbank(1)    INTTA1(void)
{      ad_start();                        // ADC Ľ
       if(aux125!=0)                      // 1.25msec timer chk & dec
          aux125--;
        f125=0xff;                        // 1.25ms flag on
        f10ms |= sft_bit;                 // 1.25msϲ f10ms on bit 1bit  ²*/
       if(((sft_bit <<= 1) & 0xff) == 0x00)
           sft_bit=0x01;
       if(-- n125ct ==0){
          n125ct = 80;
        f0r1s  =0xff;                     // 0.1sec flag on
       if(-- n0r1ct==0){
          n0r1ct =10;
        f1sec  =0xff;}}                   // 1sec flag on
}
    // SIO ch1 ޭ غ
void __interrupt INTRX1(void)
{  __asm("PUSH   WA");
   __asm("LD     A,(_SC1CR) ");          // status byte
   __asm("LD     W,(_SC1BUF) ");         // read RX data
   __asm("AND    A,0x1c ");              // err chk
   __asm("J      NZ,LABRX1 ");           // ret then err
   __asm("LD     (_RXD1),W ");           // store data
   ST_FLG |= 0x80;                       // received flg on
   __asm("LABRX1: ");
   __asm("POP    WA ");
}

    //   A/D ݶ غ  
void __regbank(-1)  _Int_AD(void)
{        ST_FLG |= 0x20;               // set 5,(ST_FLG)  A/D DATA READY FLG ON
}

    // DMAݿ خ غ
void __regbank(-1)  _Int_TC1(void)
{        INTETC01 = 0x00;              // DMAغ ݼ
         ST_FLG &= 0xfb;               // res 2,(ST_FLG) ر ݿ FLG OFF
         aux125 = 2;                   // 1.25 *n TIM SET
}

/*=====     Interrupt vect table    ========*/
#pragma section const  inttbl
void    * const _IntTbl[] =
{         _startup          // Reset/SWI 0
         ,_Int_dummy        // SWI 1
         ,_Int_dummy        // INTUNDEF/SWI 2
         ,_Int_dummy        // SWI 3
         ,_Int_dummy        // SWI 4
         ,_Int_dummy        // SWI 5
         ,_Int_dummy        // SWI 6
         ,_Int_dummy        // SWI 7
         ,_Int_dummy        // NMI
         ,_Int_dummy        // INTWD
         ,INT0_Z            // INT0
         ,_Int_dummy        // INT1
         ,_Int_dummy        // INT2
         ,_Int_dummy        // INT3
         ,_Int_dummy        // INT4
         ,_Int_dummy        // INT5
         ,_Int_dummy        // INT6
         ,_Int_dummy        // INT7
         ,_Int_dummy        // INT8
         ,_Int_dummy        // INTTA0
         ,INTTA1            // INTTA1
         ,_Int_dummy        // INTTA2
         ,_Int_dummy        // INTTA3
         ,_Int_dummy        // INTTA4
         ,_Int_dummy        // INTTA5
         ,_Int_dummy        // INTTA6
         ,_Int_dummy        // INTTA7
         ,_Int_dummy        // INTTB00
         ,_Int_dummy        // INTTB01
         ,_Int_dummy        // INTTB10
         ,_Int_dummy        // INTTB11
         ,_Int_dummy        // INTTBOF0
         ,_Int_dummy        // INTTBOF1
         ,_Int_dummy        // INTRX0
         ,_Int_dummy        // INTTX0
         ,INTRX1            // INTRX1
         ,_Int_dummy        // INTTX1
         ,_Int_dummy        // INTS2 
         ,_Int_dummy        // INTRTC
         ,_Int_AD           // INTAD
         ,_Int_dummy        // INTTC0
         ,_Int_TC1          // INTTC1
         ,_Int_dummy        // INTTC2
         ,_Int_dummy        // INTTC3
};
