/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: locale.h,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2003/05/20 09:59:24 $	*/

#ifndef	__LOCALE_H
#define	__LOCALE_H

#ifndef	NULL
#define	NULL	((void *)0)
#endif

/* locale categories */
#define	LC_ALL		0
#define	LC_COLLATE	1
#define	LC_CTYPE	2
#define	LC_MONETARY	3
#define	LC_NUMERIC	4
#define	LC_TIME		5

/* local convention structure */
struct lconv {
	char	*decimal_point;
	char	*thousands_sep;
	char	*grouping;
	char	*int_curr_symbol;
	char	*currency_symbol;
	char	*mon_decimal_point;
	char	*mon_thousands_sep;
	char	*mon_grouping;
	char	*positive_sign;
	char	*negative_sign;
	char	int_frac_digits;
	char	frac_digits;
	char	p_cs_precedes;
	char	p_sep_by_space;
	char	n_cs_precedes;
	char	n_sep_by_space;
	char	p_sign_posn;
	char	n_sign_posn;
};

#ifndef	__CDECL
#if	__STDC__
#define __CDECL
#else
#define __CDECL __cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

/* ANSI */
/* Not Support */	/*	struct lconv * __CDECL	localeconv(void);			*/
/* Not Support */	/*	char * __CDECL	setlocale(int category, const char *locale);	*/
#endif	/* __LOCALE_H */
