/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: math.h,v $	*/
/*	$Revision: 1.3 $	*/
/*	$Date: 2003/05/22 02:57:01 $	*/

#ifndef	__MATH_H
#define	__MATH_H

#ifndef	__CDECL
#if	__STDC__
#define	__CDECL
#else
#define	__CDECL	__cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#ifdef UDE_CC	/* using UDE C compiler floating fixed number convert */

/*	#define	HUGE_VAL	1.7976931348623157e+308	*/
#define	HUGE_VAL	1.79769313486231500e+308		/* for using Watcom C	*/

#else		/* floating fixed number bit pattern definition */

#ifndef __FLOAT_H

typedef union {
	unsigned char dat[4] ;
	float	val ;
} FLTBIT ;

typedef union {
	unsigned char dat[8] ;
	double	val ;
} DBLBIT ;

typedef union {
	unsigned char dat[10] ;
	long double	val ;
} LDBLBIT ;

#endif

extern	DBLBIT __far_pid g_mathtbl[] ;

#define	HUGE_VAL	g_mathtbl[0].val

#endif

#define LN_DBLMAX	709.778
#define LN_DBLMIN	-708.396

/* ANSI */
double __CDECL	__far_pic acos(double x);
double __CDECL	__far_pic asin(double x);
double __CDECL	__far_pic atan(double x);
double __CDECL	__far_pic atan2(double y, double x);
double __CDECL	__far_pic ceil(double x);
double __CDECL	__far_pic cos(double x);
double __CDECL	__far_pic cosh(double x);
double __CDECL	__far_pic exp(double x);
double __CDECL	__far_pic fabs(double x);
double __CDECL	__far_pic floor(double x);
double __CDECL	__far_pic fmod(double x, double y);
double __CDECL	__far_pic frexp(double value, int *exp);
double __CDECL	__far_pic ldexp(double x, int exp);
double __CDECL	__far_pic log(double x);
double __CDECL	__far_pic log10(double x);
double __CDECL	__far_pic modf(double value, double *iptr);
double __CDECL	__far_pic pow(double x, double y);
double __CDECL	__far_pic sin(double x);
double __CDECL	__far_pic sinh(double x);
double __CDECL	__far_pic sqrt(double x);
double __CDECL	__far_pic tan(double x);
double __CDECL	__far_pic tanh(double x);

#endif	/* __MATH_H	*/
