/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: stdio.h,v $	*/
/*	$Revision: 1.3 $	*/
/*	$Date: 2003/05/22 02:57:37 $	*/

#ifndef	__STDIO_H
#define	__STDIO_H

#ifndef	__CDECL
#if	__STDC__
#define	__CDECL
#else
#define	__CDECL	__cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#ifndef	__SIZE_T
#define	__SIZE_T
typedef	unsigned int	size_t;
#endif

#ifndef	__VA_LIST
#define	__VA_LIST
typedef char *va_list;
#endif

#ifndef	NULL
#define	NULL	((void *)0)
#endif

#ifndef EOF
#define	EOF	(-1)
#endif

/*
#define _IOFBF
#define _IOLBF
#define _IONBF
#define BUFSIZ
#define FOPEN_MAX
#define FILENAME_MAX
#define L_tmpnam
#define SEEK_CUR
#define SEEK_END
#define SEEK_SET
#define TMP_MAX
typedef long fpos_t;
*/

#define __UNGETC	0x04
#define __BUSY		0x80

typedef struct {
	void		(*out) (unsigned char);	/* Output routine */
	unsigned char	(*in) (void);		/* Input routine for device */
	int 		unget;
	int		flag;
} FILE;

/* ANSI */
int __CDECL	__far_pic fgetc(FILE *stream);
char * __CDECL	__far_pic fgets(char *s, int n, FILE *stream);
int __CDECL	__far_pic fprintf(FILE *stream, const char *format, ...);
int __CDECL	__far_pic fputc(int c, FILE *stream);
int __CDECL	__far_pic fputs(const char *s, FILE *stream);
size_t __CDECL	__far_pic fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
int __CDECL	__far_pic fscanf(FILE *stream, const char *format, ...);
size_t __CDECL	__far_pic fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
/* By Macro */	/*	int __CDECL	getc(FILE *stream);							*/
/* By Macro */	/*	int __CDECL	putc(int c, FILE *stream);						*/
int __CDECL	__far_pic sprintf(char *s, const char *format, ...);
int __CDECL	__far_pic sscanf(const char *s, const char *format, ...);
int __CDECL	__far_pic ungetc(int c, FILE *stream);
int __CDECL	__far_pic vfprintf(FILE *stream, const char *format, va_list arg);
int __CDECL	__far_pic vsprintf(char *s, const char *format, va_list arg);

/* Reserve */	/*	int __CDECL	getchar(void);								*/
/* Reserve */	/*	char * __CDECL	gets(char *s);								*/
/* Reserve */	/*	int __CDECL	printf(const char *format, ...);					*/
/* Reserve */	/*	int __CDECL	putchar(int c);								*/
/* Reserve */	/*	int __CDECL	puts(const char *s);							*/
/* Reserve */	/*	int __CDECL	scanf(const char *format, ...);						*/
/* Reserve */	/*	int __CDECL	vprintf(const char *format, va_list arg);				*/

/* Not Support */	/*	int __CDECL	clearerr(FILE *stream);						*/
/* Not Support */	/*	int __CDECL	fclose(FILE *stream);						*/
/* Not Support */	/*	int __CDECL	feof(FILE *stream);						*/
/* Not Support */	/*	int __CDECL	ferror(FILE *stream);						*/
/* Not Support */	/*	int __CDECL	fflush(FILE *stream);						*/
/* Not Support */	/*	int __CDECL	fgetpos(FILE *stream, fpos_t *pos);				*/
/* Not Support */	/*	FILE * __CDECL	fopen(const char *filename, const char *mode);			*/
/* Not Support */	/*	FILE * __CDECL	freopen(const char *filename,const char *mode, FILE *stream);	*/
/* Not Support */	/*	int __CDECL	fseek(FILE *stream, long int offset, int whence);		*/
/* Not Support */	/*	int __CDECL	fsetpos(FILE *stream, const fpos_t *pos);			*/
/* Not Support */	/*	long int __CDECL	ftell(FILE *stream);					*/
/* Not Support */	/*	void __CDECL	perror(const char *s);						*/
/* Not Support */	/*	int __CDECL	remove(const char *filename);					*/
/* Not Support */	/*	int __CDECL	rename(const char *old, const char *new);			*/
/* Not Support */	/*	void __CDECL	rewind(FILE *stream);						*/
/* Not Support */	/*	void __CDECL	setbuf(FILE *stream, char *buf);				*/
/* Not Support */	/*	int __CDECL	setvbuf(FILE *stream, char *buf);				*/
/* Not Support */	/*	FILE * __CDECL	tmpfile(void);							*/
/* Not Support */	/*	char * __CDECL	tmpnam(char *s);						*/

#define 	putc(c, fp)	fputc(c, fp)
#define 	getc(fp)	fgetc(fp)

/* Softools */
void __CDECL	__far_pic fassign(FILE *stream, unsigned char (*in)(void), void (*out)(unsigned char c));

#endif	/* __STDIO_H	*/
