/*      Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved        */
/*	$RCSfile: _tan.c,v $	*/
/*	$Revision: 1.5 $	*/
/*	$Date: 2003/05/13 01:08:32 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <float.h>
#include <math.h>
#include <errno.h>

double __CDECL tan(double  x)
{
	unsigned short* p;
	double	ret;

	p=(unsigned short*)&x;

#if defined (__900__) || defined (__870__) || defined (__870X__) || defined (__90__) || defined (__870C__)
	if(LMTPOW<=(p[3]&0x7ff0))
#else
	if(LMTPOW<=(p[0]&0x7ff0))
#endif
        {
		errno=ERANGE;		/* TLOSS error */
		return(0.0);
	}
	ret = sin(x) / cos(x);
	return(ret);
}
