/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _sscanf.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:03:27 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdio.h>
#include <stdarg.h>

int __CDECL	_doscan(const char *fmt, va_list args, int (*fnc)(void), void (*ungetfnc)(int c));

static void __CDECL	_setstrchar(char *s);
static int __CDECL	_getstrchar(void);
static void __CDECL	_ungetstrchar(int c);

static char	*str_p;

int __CDECL	sscanf(const char *s, const char *format, ...)
{
	va_list	args;

        str_p = (char *)s;
	va_start(args, format);
	return (_doscan(format, args, _getstrchar, _ungetstrchar));
}

static void __CDECL	_setstrchar(char *s)
{
        str_p = s ;
}

static int __CDECL	_getstrchar(void)
{
	return ((int)*str_p++);
}

static void __CDECL	_ungetstrchar(int c)
{
/*	*--str_p = (char)c;	*/
	--str_p;
}
