/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: __search.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:07:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdlib.h>
#include <string.h>

void * __CDECL _lsearch(const void *key, void *base, size_t *nmemb, size_t size, int (*compar)(const void *, const void *), int flag)
{
        int    i;
	char	*p;

        for (i = *nmemb; i > 0; --i) {
                if (((*compar)(key, base)) == 0)	return (base);
		p = (char *)base;
                p += size;
		base = (void *)p;
        }
        if (flag) {
                (*nmemb)++;
                memmove(base, (void *)key, size);
        }
        else	base = NULL;
        return (base);
}
